/**
 * @license AngularJS v1.0.8
 * (c) 2010-2012 Google, Inc. http://angularjs.org
 * License: MIT
 */
!function(window,document,undefined){"use strict";function isArrayLike(obj){return obj&&"number"==typeof obj.length?"function"!=typeof obj.hasOwnProperty&&"function"!=typeof obj.constructor?!0:obj instanceof JQLite||jQuery&&obj instanceof jQuery||"[object Object]"!==toString.call(obj)||"function"==typeof obj.callee:!1}function forEach(obj,iterator,context){var key;if(obj)if(isFunction(obj))for(key in obj)"prototype"!=key&&"length"!=key&&"name"!=key&&obj.hasOwnProperty(key)&&iterator.call(context,obj[key],key);else if(obj.forEach&&obj.forEach!==forEach)obj.forEach(iterator,context);else if(isArrayLike(obj))for(key=0;key<obj.length;key++)iterator.call(context,obj[key],key);else for(key in obj)obj.hasOwnProperty(key)&&iterator.call(context,obj[key],key);return obj}function sortedKeys(obj){var keys=[];for(var key in obj)obj.hasOwnProperty(key)&&keys.push(key);return keys.sort()}function forEachSorted(obj,iterator,context){for(var keys=sortedKeys(obj),i=0;i<keys.length;i++)iterator.call(context,obj[keys[i]],keys[i]);return keys}function reverseParams(iteratorFn){return function(value,key){iteratorFn(key,value)}}function nextUid(){for(var digit,index=uid.length;index;){if(index--,digit=uid[index].charCodeAt(0),57==digit)return uid[index]="A",uid.join("");if(90!=digit)return uid[index]=String.fromCharCode(digit+1),uid.join("");uid[index]="0"}return uid.unshift("0"),uid.join("")}function setHashKey(obj,h){h?obj.$$hashKey=h:delete obj.$$hashKey}function extend(dst){var h=dst.$$hashKey;return forEach(arguments,function(obj){obj!==dst&&forEach(obj,function(value,key){dst[key]=value})}),setHashKey(dst,h),dst}function int(str){return parseInt(str,10)}function inherit(parent,extra){return extend(new(extend(function(){},{prototype:parent})),extra)}function noop(){}function identity($){return $}function valueFn(value){return function(){return value}}function isUndefined(value){return"undefined"==typeof value}function isDefined(value){return"undefined"!=typeof value}function isObject(value){return null!=value&&"object"==typeof value}function isString(value){return"string"==typeof value}function isNumber(value){return"number"==typeof value}function isDate(value){return"[object Date]"==toString.apply(value)}function isArray(value){return"[object Array]"==toString.apply(value)}function isFunction(value){return"function"==typeof value}function isRegExp(value){return"[object RegExp]"==toString.apply(value)}function isWindow(obj){return obj&&obj.document&&obj.location&&obj.alert&&obj.setInterval}function isScope(obj){return obj&&obj.$evalAsync&&obj.$watch}function isFile(obj){return"[object File]"===toString.apply(obj)}function isElement(node){return node&&(node.nodeName||node.bind&&node.find)}function map(obj,iterator,context){var results=[];return forEach(obj,function(value,index,list){results.push(iterator.call(context,value,index,list))}),results}function includes(array,obj){return-1!=indexOf(array,obj)}function indexOf(array,obj){if(array.indexOf)return array.indexOf(obj);for(var i=0;i<array.length;i++)if(obj===array[i])return i;return-1}function arrayRemove(array,value){var index=indexOf(array,value);return index>=0&&array.splice(index,1),value}function copy(source,destination){if(isWindow(source)||isScope(source))throw Error("Can't copy Window or Scope");if(destination){if(source===destination)throw Error("Can't copy equivalent objects or arrays");if(isArray(source)){destination.length=0;for(var i=0;i<source.length;i++)destination.push(copy(source[i]))}else{var h=destination.$$hashKey;forEach(destination,function(value,key){delete destination[key]});for(var key in source)destination[key]=copy(source[key]);setHashKey(destination,h)}}else destination=source,source&&(isArray(source)?destination=copy(source,[]):isDate(source)?destination=new Date(source.getTime()):isRegExp(source)?destination=new RegExp(source.source):isObject(source)&&(destination=copy(source,{})));return destination}function shallowCopy(src,dst){dst=dst||{};for(var key in src)src.hasOwnProperty(key)&&"$$"!==key.substr(0,2)&&(dst[key]=src[key]);return dst}function equals(o1,o2){if(o1===o2)return!0;if(null===o1||null===o2)return!1;if(o1!==o1&&o2!==o2)return!0;var length,key,keySet,t1=typeof o1,t2=typeof o2;if(t1==t2&&"object"==t1){if(!isArray(o1)){if(isDate(o1))return isDate(o2)&&o1.getTime()==o2.getTime();if(isRegExp(o1)&&isRegExp(o2))return o1.toString()==o2.toString();if(isScope(o1)||isScope(o2)||isWindow(o1)||isWindow(o2)||isArray(o2))return!1;keySet={};for(key in o1)if("$"!==key.charAt(0)&&!isFunction(o1[key])){if(!equals(o1[key],o2[key]))return!1;keySet[key]=!0}for(key in o2)if(!keySet[key]&&"$"!==key.charAt(0)&&o2[key]!==undefined&&!isFunction(o2[key]))return!1;return!0}if(!isArray(o2))return!1;if((length=o1.length)==o2.length){for(key=0;length>key;key++)if(!equals(o1[key],o2[key]))return!1;return!0}}return!1}function concat(array1,array2,index){return array1.concat(slice.call(array2,index))}function sliceArgs(args,startIndex){return slice.call(args,startIndex||0)}function bind(self,fn){var curryArgs=arguments.length>2?sliceArgs(arguments,2):[];return!isFunction(fn)||fn instanceof RegExp?fn:curryArgs.length?function(){return arguments.length?fn.apply(self,curryArgs.concat(slice.call(arguments,0))):fn.apply(self,curryArgs)}:function(){return arguments.length?fn.apply(self,arguments):fn.call(self)}}function toJsonReplacer(key,value){var val=value;return/^\$+/.test(key)?val=undefined:isWindow(value)?val="$WINDOW":value&&document===value?val="$DOCUMENT":isScope(value)&&(val="$SCOPE"),val}function toJson(obj,pretty){return"undefined"==typeof obj?undefined:JSON.stringify(obj,toJsonReplacer,pretty?"  ":null)}function fromJson(json){return isString(json)?JSON.parse(json):json}function toBoolean(value){if(value&&0!==value.length){var v=lowercase(""+value);value=!("f"==v||"0"==v||"false"==v||"no"==v||"n"==v||"[]"==v)}else value=!1;return value}function startingTag(element){element=jqLite(element).clone();try{element.html("")}catch(e){}var TEXT_NODE=3,elemHtml=jqLite("<div>").append(element).html();try{return element[0].nodeType===TEXT_NODE?lowercase(elemHtml):elemHtml.match(/^(<[^>]+>)/)[1].replace(/^<([\w\-]+)/,function(match,nodeName){return"<"+lowercase(nodeName)})}catch(e){return lowercase(elemHtml)}}function tryDecodeURIComponent(value){try{return decodeURIComponent(value)}catch(e){}}function parseKeyValue(keyValue){var key_value,key,obj={};return forEach((keyValue||"").split("&"),function(keyValue){keyValue&&(key_value=keyValue.split("="),key=tryDecodeURIComponent(key_value[0]),isDefined(key)&&(obj[key]=isDefined(key_value[1])?tryDecodeURIComponent(key_value[1]):!0))}),obj}function toKeyValue(obj){var parts=[];return forEach(obj,function(value,key){parts.push(encodeUriQuery(key,!0)+(value===!0?"":"="+encodeUriQuery(value,!0)))}),parts.length?parts.join("&"):""}function encodeUriSegment(val){return encodeUriQuery(val,!0).replace(/%26/gi,"&").replace(/%3D/gi,"=").replace(/%2B/gi,"+")}function encodeUriQuery(val,pctEncodeSpaces){return encodeURIComponent(val).replace(/%40/gi,"@").replace(/%3A/gi,":").replace(/%24/g,"$").replace(/%2C/gi,",").replace(/%20/g,pctEncodeSpaces?"%20":"+")}function angularInit(element,bootstrap){function append(element){element&&elements.push(element)}var appElement,module,elements=[element],names=["ng:app","ng-app","x-ng-app","data-ng-app"],NG_APP_CLASS_REGEXP=/\sng[:\-]app(:\s*([\w\d_]+);?)?\s/;forEach(names,function(name){names[name]=!0,append(document.getElementById(name)),name=name.replace(":","\\:"),element.querySelectorAll&&(forEach(element.querySelectorAll("."+name),append),forEach(element.querySelectorAll("."+name+"\\:"),append),forEach(element.querySelectorAll("["+name+"]"),append))}),forEach(elements,function(element){if(!appElement){var className=" "+element.className+" ",match=NG_APP_CLASS_REGEXP.exec(className);match?(appElement=element,module=(match[2]||"").replace(/\s+/g,",")):forEach(element.attributes,function(attr){!appElement&&names[attr.name]&&(appElement=element,module=attr.value)})}}),appElement&&bootstrap(appElement,module?[module]:[])}function bootstrap(element,modules){var doBootstrap=function(){element=jqLite(element),modules=modules||[],modules.unshift(["$provide",function($provide){$provide.value("$rootElement",element)}]),modules.unshift("ng");var injector=createInjector(modules);return injector.invoke(["$rootScope","$rootElement","$compile","$injector",function(scope,element,compile,injector){scope.$apply(function(){element.data("$injector",injector),compile(element)(scope)})}]),injector},NG_DEFER_BOOTSTRAP=/^NG_DEFER_BOOTSTRAP!/;return window&&!NG_DEFER_BOOTSTRAP.test(window.name)?doBootstrap():(window.name=window.name.replace(NG_DEFER_BOOTSTRAP,""),angular.resumeBootstrap=function(extraModules){forEach(extraModules,function(module){modules.push(module)}),doBootstrap()},void 0)}function snake_case(name,separator){return separator=separator||"_",name.replace(SNAKE_CASE_REGEXP,function(letter,pos){return(pos?separator:"")+letter.toLowerCase()})}function bindJQuery(){jQuery=window.jQuery,jQuery?(jqLite=jQuery,extend(jQuery.fn,{scope:JQLitePrototype.scope,controller:JQLitePrototype.controller,injector:JQLitePrototype.injector,inheritedData:JQLitePrototype.inheritedData}),JQLitePatchJQueryRemove("remove",!0,!0,!1),JQLitePatchJQueryRemove("empty",!1,!1,!1),JQLitePatchJQueryRemove("html",!1,!1,!0)):jqLite=JQLite,angular.element=jqLite}function assertArg(arg,name,reason){if(!arg)throw new Error("Argument '"+(name||"?")+"' is "+(reason||"required"));return arg}function assertArgFn(arg,name,acceptArrayAnnotation){return acceptArrayAnnotation&&isArray(arg)&&(arg=arg[arg.length-1]),assertArg(isFunction(arg),name,"not a function, got "+(arg&&"object"==typeof arg?arg.constructor.name||"Object":typeof arg)),arg}function getter(obj,path,bindFnToScope){if(!path)return obj;for(var key,keys=path.split("."),lastInstance=obj,len=keys.length,i=0;len>i;i++)key=keys[i],obj&&(obj=(lastInstance=obj)[key]);return!bindFnToScope&&isFunction(obj)?bind(lastInstance,obj):obj}function setupModuleLoader(window){function ensure(obj,name,factory){return obj[name]||(obj[name]=factory())}return ensure(ensure(window,"angular",Object),"module",function(){var modules={};return function(name,requires,configFn){return requires&&modules.hasOwnProperty(name)&&(modules[name]=null),ensure(modules,name,function(){function invokeLater(provider,method,insertMethod){return function(){return invokeQueue[insertMethod||"push"]([provider,method,arguments]),moduleInstance}}if(!requires)throw Error("No module: "+name);var invokeQueue=[],runBlocks=[],config=invokeLater("$injector","invoke"),moduleInstance={_invokeQueue:invokeQueue,_runBlocks:runBlocks,requires:requires,name:name,provider:invokeLater("$provide","provider"),factory:invokeLater("$provide","factory"),service:invokeLater("$provide","service"),value:invokeLater("$provide","value"),constant:invokeLater("$provide","constant","unshift"),filter:invokeLater("$filterProvider","register"),controller:invokeLater("$controllerProvider","register"),directive:invokeLater("$compileProvider","directive"),config:config,run:function(block){return runBlocks.push(block),this}};return configFn&&config(configFn),moduleInstance})}})}function publishExternalAPI(angular){extend(angular,{bootstrap:bootstrap,copy:copy,extend:extend,equals:equals,element:jqLite,forEach:forEach,injector:createInjector,noop:noop,bind:bind,toJson:toJson,fromJson:fromJson,identity:identity,isUndefined:isUndefined,isDefined:isDefined,isString:isString,isFunction:isFunction,isObject:isObject,isNumber:isNumber,isElement:isElement,isArray:isArray,version:version,isDate:isDate,lowercase:lowercase,uppercase:uppercase,callbacks:{counter:0}}),angularModule=setupModuleLoader(window);try{angularModule("ngLocale")}catch(e){angularModule("ngLocale",[]).provider("$locale",$LocaleProvider)}angularModule("ng",["ngLocale"],["$provide",function($provide){$provide.provider("$compile",$CompileProvider).directive({a:htmlAnchorDirective,input:inputDirective,textarea:inputDirective,form:formDirective,script:scriptDirective,select:selectDirective,style:styleDirective,option:optionDirective,ngBind:ngBindDirective,ngBindHtmlUnsafe:ngBindHtmlUnsafeDirective,ngBindTemplate:ngBindTemplateDirective,ngClass:ngClassDirective,ngClassEven:ngClassEvenDirective,ngClassOdd:ngClassOddDirective,ngCsp:ngCspDirective,ngCloak:ngCloakDirective,ngController:ngControllerDirective,ngForm:ngFormDirective,ngHide:ngHideDirective,ngInclude:ngIncludeDirective,ngInit:ngInitDirective,ngNonBindable:ngNonBindableDirective,ngPluralize:ngPluralizeDirective,ngRepeat:ngRepeatDirective,ngShow:ngShowDirective,ngStyle:ngStyleDirective,ngSwitch:ngSwitchDirective,ngSwitchWhen:ngSwitchWhenDirective,ngSwitchDefault:ngSwitchDefaultDirective,ngOptions:ngOptionsDirective,ngView:ngViewDirective,ngTransclude:ngTranscludeDirective,ngModel:ngModelDirective,ngList:ngListDirective,ngChange:ngChangeDirective,required:requiredDirective,ngRequired:requiredDirective,ngValue:ngValueDirective}).directive(ngAttributeAliasDirectives).directive(ngEventDirectives),$provide.provider({$anchorScroll:$AnchorScrollProvider,$browser:$BrowserProvider,$cacheFactory:$CacheFactoryProvider,$controller:$ControllerProvider,$document:$DocumentProvider,$exceptionHandler:$ExceptionHandlerProvider,$filter:$FilterProvider,$interpolate:$InterpolateProvider,$http:$HttpProvider,$httpBackend:$HttpBackendProvider,$location:$LocationProvider,$log:$LogProvider,$parse:$ParseProvider,$route:$RouteProvider,$routeParams:$RouteParamsProvider,$rootScope:$RootScopeProvider,$q:$QProvider,$sniffer:$SnifferProvider,$templateCache:$TemplateCacheProvider,$timeout:$TimeoutProvider,$window:$WindowProvider})}])}function jqNextId(){return++jqId}function camelCase(name){return name.replace(SPECIAL_CHARS_REGEXP,function(_,separator,letter,offset){return offset?letter.toUpperCase():letter}).replace(MOZ_HACK_REGEXP,"Moz$1")}function JQLitePatchJQueryRemove(name,dispatchThis,filterElems,getterIfNoArguments){function removePatch(param){var set,setIndex,setLength,element,childIndex,childLength,children,list=filterElems&&param?[this.filter(param)]:[this],fireEvent=dispatchThis;if(!getterIfNoArguments||null!=param)for(;list.length;)for(set=list.shift(),setIndex=0,setLength=set.length;setLength>setIndex;setIndex++)for(element=jqLite(set[setIndex]),fireEvent?element.triggerHandler("$destroy"):fireEvent=!fireEvent,childIndex=0,childLength=(children=element.children()).length;childLength>childIndex;childIndex++)list.push(jQuery(children[childIndex]));return originalJqFn.apply(this,arguments)}var originalJqFn=jQuery.fn[name];originalJqFn=originalJqFn.$original||originalJqFn,removePatch.$original=originalJqFn,jQuery.fn[name]=removePatch}function JQLite(element){if(element instanceof JQLite)return element;if(!(this instanceof JQLite)){if(isString(element)&&"<"!=element.charAt(0))throw Error("selectors not implemented");return new JQLite(element)}if(isString(element)){var div=document.createElement("div");div.innerHTML="<div>&#160;</div>"+element,div.removeChild(div.firstChild),JQLiteAddNodes(this,div.childNodes),this.remove()}else JQLiteAddNodes(this,element)}function JQLiteClone(element){return element.cloneNode(!0)}function JQLiteDealoc(element){JQLiteRemoveData(element);for(var i=0,children=element.childNodes||[];i<children.length;i++)JQLiteDealoc(children[i])}function JQLiteUnbind(element,type,fn){var events=JQLiteExpandoStore(element,"events"),handle=JQLiteExpandoStore(element,"handle");handle&&(isUndefined(type)?forEach(events,function(eventHandler,type){removeEventListenerFn(element,type,eventHandler),delete events[type]}):isUndefined(fn)?(removeEventListenerFn(element,type,events[type]),delete events[type]):arrayRemove(events[type]||[],fn))}function JQLiteRemoveData(element){var expandoId=element[jqName],expandoStore=jqCache[expandoId];expandoStore&&(expandoStore.handle&&(expandoStore.events.$destroy&&expandoStore.handle({},"$destroy"),JQLiteUnbind(element)),delete jqCache[expandoId],element[jqName]=undefined)}function JQLiteExpandoStore(element,key,value){var expandoId=element[jqName],expandoStore=jqCache[expandoId||-1];return isDefined(value)?(expandoStore||(element[jqName]=expandoId=jqNextId(),expandoStore=jqCache[expandoId]={}),expandoStore[key]=value,void 0):expandoStore&&expandoStore[key]}function JQLiteData(element,key,value){var data=JQLiteExpandoStore(element,"data"),isSetter=isDefined(value),keyDefined=!isSetter&&isDefined(key),isSimpleGetter=keyDefined&&!isObject(key);if(data||isSimpleGetter||JQLiteExpandoStore(element,"data",data={}),isSetter)data[key]=value;else{if(!keyDefined)return data;if(isSimpleGetter)return data&&data[key];extend(data,key)}}function JQLiteHasClass(element,selector){return(" "+element.className+" ").replace(/[\n\t]/g," ").indexOf(" "+selector+" ")>-1}function JQLiteRemoveClass(element,cssClasses){cssClasses&&forEach(cssClasses.split(" "),function(cssClass){element.className=trim((" "+element.className+" ").replace(/[\n\t]/g," ").replace(" "+trim(cssClass)+" "," "))})}function JQLiteAddClass(element,cssClasses){cssClasses&&forEach(cssClasses.split(" "),function(cssClass){JQLiteHasClass(element,cssClass)||(element.className=trim(element.className+" "+trim(cssClass)))})}function JQLiteAddNodes(root,elements){if(elements){elements=elements.nodeName||!isDefined(elements.length)||isWindow(elements)?[elements]:elements;for(var i=0;i<elements.length;i++)root.push(elements[i])}}function JQLiteController(element,name){return JQLiteInheritedData(element,"$"+(name||"ngController")+"Controller")}function JQLiteInheritedData(element,name,value){for(element=jqLite(element),9==element[0].nodeType&&(element=element.find("html"));element.length;){if(value=element.data(name))return value;element=element.parent()}}function getBooleanAttrName(element,name){var booleanAttr=BOOLEAN_ATTR[name.toLowerCase()];return booleanAttr&&BOOLEAN_ELEMENTS[element.nodeName]&&booleanAttr}function createEventHandler(element,events){var eventHandler=function(event,type){if(event.preventDefault||(event.preventDefault=function(){event.returnValue=!1}),event.stopPropagation||(event.stopPropagation=function(){event.cancelBubble=!0}),event.target||(event.target=event.srcElement||document),isUndefined(event.defaultPrevented)){var prevent=event.preventDefault;event.preventDefault=function(){event.defaultPrevented=!0,prevent.call(event)},event.defaultPrevented=!1}event.isDefaultPrevented=function(){return event.defaultPrevented},forEach(events[type||event.type],function(fn){fn.call(element,event)}),8>=msie?(event.preventDefault=null,event.stopPropagation=null,event.isDefaultPrevented=null):(delete event.preventDefault,delete event.stopPropagation,delete event.isDefaultPrevented)};return eventHandler.elem=element,eventHandler}function hashKey(obj){var key,objType=typeof obj;return"object"==objType&&null!==obj?"function"==typeof(key=obj.$$hashKey)?key=obj.$$hashKey():key===undefined&&(key=obj.$$hashKey=nextUid()):key=obj,objType+":"+key}function HashMap(array){forEach(array,this.put,this)}function HashQueueMap(){}function annotate(fn){var $inject,fnText,argDecl,last;return"function"==typeof fn?($inject=fn.$inject)||($inject=[],fnText=fn.toString().replace(STRIP_COMMENTS,""),argDecl=fnText.match(FN_ARGS),forEach(argDecl[1].split(FN_ARG_SPLIT),function(arg){arg.replace(FN_ARG,function(all,underscore,name){$inject.push(name)})}),fn.$inject=$inject):isArray(fn)?(last=fn.length-1,assertArgFn(fn[last],"fn"),$inject=fn.slice(0,last)):assertArgFn(fn,"fn",!0),$inject}function createInjector(modulesToLoad){function supportObject(delegate){return function(key,value){return isObject(key)?(forEach(key,reverseParams(delegate)),void 0):delegate(key,value)}}function provider(name,provider_){if((isFunction(provider_)||isArray(provider_))&&(provider_=providerInjector.instantiate(provider_)),!provider_.$get)throw Error("Provider "+name+" must define $get factory method.");return providerCache[name+providerSuffix]=provider_}function factory(name,factoryFn){return provider(name,{$get:factoryFn})}function service(name,constructor){return factory(name,["$injector",function($injector){return $injector.instantiate(constructor)}])}function value(name,value){return factory(name,valueFn(value))}function constant(name,value){providerCache[name]=value,instanceCache[name]=value}function decorator(serviceName,decorFn){var origProvider=providerInjector.get(serviceName+providerSuffix),orig$get=origProvider.$get;origProvider.$get=function(){var origInstance=instanceInjector.invoke(orig$get,origProvider);return instanceInjector.invoke(decorFn,null,{$delegate:origInstance})}}function loadModules(modulesToLoad){var runBlocks=[];return forEach(modulesToLoad,function(module){if(!loadedModules.get(module))if(loadedModules.put(module,!0),isString(module)){var moduleFn=angularModule(module);runBlocks=runBlocks.concat(loadModules(moduleFn.requires)).concat(moduleFn._runBlocks);try{for(var invokeQueue=moduleFn._invokeQueue,i=0,ii=invokeQueue.length;ii>i;i++){var invokeArgs=invokeQueue[i],provider="$injector"==invokeArgs[0]?providerInjector:providerInjector.get(invokeArgs[0]);provider[invokeArgs[1]].apply(provider,invokeArgs[2])}}catch(e){throw e.message&&(e.message+=" from "+module),e}}else if(isFunction(module))try{runBlocks.push(providerInjector.invoke(module))}catch(e){throw e.message&&(e.message+=" from "+module),e}else if(isArray(module))try{runBlocks.push(providerInjector.invoke(module))}catch(e){throw e.message&&(e.message+=" from "+String(module[module.length-1])),e}else assertArgFn(module,"module")}),runBlocks}function createInternalInjector(cache,factory){function getService(serviceName){if("string"!=typeof serviceName)throw Error("Service name expected");if(cache.hasOwnProperty(serviceName)){if(cache[serviceName]===INSTANTIATING)throw Error("Circular dependency: "+path.join(" <- "));return cache[serviceName]}try{return path.unshift(serviceName),cache[serviceName]=INSTANTIATING,cache[serviceName]=factory(serviceName)}finally{path.shift()}}function invoke(fn,self,locals){var length,i,key,args=[],$inject=annotate(fn);for(i=0,length=$inject.length;length>i;i++)key=$inject[i],args.push(locals&&locals.hasOwnProperty(key)?locals[key]:getService(key));switch(fn.$inject||(fn=fn[length]),self?-1:args.length){case 0:return fn();case 1:return fn(args[0]);case 2:return fn(args[0],args[1]);case 3:return fn(args[0],args[1],args[2]);case 4:return fn(args[0],args[1],args[2],args[3]);case 5:return fn(args[0],args[1],args[2],args[3],args[4]);case 6:return fn(args[0],args[1],args[2],args[3],args[4],args[5]);case 7:return fn(args[0],args[1],args[2],args[3],args[4],args[5],args[6]);case 8:return fn(args[0],args[1],args[2],args[3],args[4],args[5],args[6],args[7]);case 9:return fn(args[0],args[1],args[2],args[3],args[4],args[5],args[6],args[7],args[8]);case 10:return fn(args[0],args[1],args[2],args[3],args[4],args[5],args[6],args[7],args[8],args[9]);default:return fn.apply(self,args)}}function instantiate(Type,locals){var instance,returnedValue,Constructor=function(){};return Constructor.prototype=(isArray(Type)?Type[Type.length-1]:Type).prototype,instance=new Constructor,returnedValue=invoke(Type,instance,locals),isObject(returnedValue)?returnedValue:instance}return{invoke:invoke,instantiate:instantiate,get:getService,annotate:annotate}}var INSTANTIATING={},providerSuffix="Provider",path=[],loadedModules=new HashMap,providerCache={$provide:{provider:supportObject(provider),factory:supportObject(factory),service:supportObject(service),value:supportObject(value),constant:supportObject(constant),decorator:decorator}},providerInjector=createInternalInjector(providerCache,function(){throw Error("Unknown provider: "+path.join(" <- "))}),instanceCache={},instanceInjector=instanceCache.$injector=createInternalInjector(instanceCache,function(servicename){var provider=providerInjector.get(servicename+providerSuffix);return instanceInjector.invoke(provider.$get,provider)});return forEach(loadModules(modulesToLoad),function(fn){instanceInjector.invoke(fn||noop)}),instanceInjector}function $AnchorScrollProvider(){var autoScrollingEnabled=!0;this.disableAutoScrolling=function(){autoScrollingEnabled=!1},this.$get=["$window","$location","$rootScope",function($window,$location,$rootScope){function getFirstAnchor(list){var result=null;return forEach(list,function(element){result||"a"!==lowercase(element.nodeName)||(result=element)}),result}function scroll(){var elm,hash=$location.hash();hash?(elm=document.getElementById(hash))?elm.scrollIntoView():(elm=getFirstAnchor(document.getElementsByName(hash)))?elm.scrollIntoView():"top"===hash&&$window.scrollTo(0,0):$window.scrollTo(0,0)}var document=$window.document;return autoScrollingEnabled&&$rootScope.$watch(function(){return $location.hash()},function(){$rootScope.$evalAsync(scroll)}),scroll}]}function Browser(window,document,$log,$sniffer){function completeOutstandingRequest(fn){try{fn.apply(null,sliceArgs(arguments,1))}finally{if(outstandingRequestCount--,0===outstandingRequestCount)for(;outstandingRequestCallbacks.length;)try{outstandingRequestCallbacks.pop()()}catch(e){$log.error(e)}}}function startPoller(interval,setTimeout){!function check(){forEach(pollFns,function(pollFn){pollFn()}),pollTimeout=setTimeout(check,interval)}()}function fireUrlChange(){lastBrowserUrl!=self.url()&&(lastBrowserUrl=self.url(),forEach(urlChangeListeners,function(listener){listener(self.url())}))}var self=this,rawDocument=document[0],location=window.location,history=window.history,setTimeout=window.setTimeout,clearTimeout=window.clearTimeout,pendingDeferIds={};self.isMock=!1;var outstandingRequestCount=0,outstandingRequestCallbacks=[];self.$$completeOutstandingRequest=completeOutstandingRequest,self.$$incOutstandingRequestCount=function(){outstandingRequestCount++},self.notifyWhenNoOutstandingRequests=function(callback){forEach(pollFns,function(pollFn){pollFn()}),0===outstandingRequestCount?callback():outstandingRequestCallbacks.push(callback)};var pollTimeout,pollFns=[];self.addPollFn=function(fn){return isUndefined(pollTimeout)&&startPoller(100,setTimeout),pollFns.push(fn),fn};var lastBrowserUrl=location.href,baseElement=document.find("base"),replacedUrl=null;self.url=function(url,replace){if(url){if(lastBrowserUrl==url)return;return lastBrowserUrl=url,$sniffer.history?replace?history.replaceState(null,"",url):(history.pushState(null,"",url),baseElement.attr("href",baseElement.attr("href"))):replace?(location.replace(url),replacedUrl=url):(location.href=url,replacedUrl=null),self}return replacedUrl||location.href.replace(/%27/g,"'")};var urlChangeListeners=[],urlChangeInit=!1;self.onUrlChange=function(callback){return urlChangeInit||($sniffer.history&&jqLite(window).bind("popstate",fireUrlChange),$sniffer.hashchange?jqLite(window).bind("hashchange",fireUrlChange):self.addPollFn(fireUrlChange),urlChangeInit=!0),urlChangeListeners.push(callback),callback},self.baseHref=function(){var href=baseElement.attr("href");return href?href.replace(/^https?\:\/\/[^\/]*/,""):""};var lastCookies={},lastCookieString="",cookiePath=self.baseHref();self.cookies=function(name,value){var cookieLength,cookieArray,cookie,i,index;if(!name){if(rawDocument.cookie!==lastCookieString)for(lastCookieString=rawDocument.cookie,cookieArray=lastCookieString.split("; "),lastCookies={},i=0;i<cookieArray.length;i++)if(cookie=cookieArray[i],index=cookie.indexOf("="),index>0){var name=unescape(cookie.substring(0,index));lastCookies[name]===undefined&&(lastCookies[name]=unescape(cookie.substring(index+1)))}return lastCookies}value===undefined?rawDocument.cookie=escape(name)+"=;path="+cookiePath+";expires=Thu, 01 Jan 1970 00:00:00 GMT":isString(value)&&(cookieLength=(rawDocument.cookie=escape(name)+"="+escape(value)+";path="+cookiePath).length+1,cookieLength>4096&&$log.warn("Cookie '"+name+"' possibly not set or overflowed because it was too large ("+cookieLength+" > 4096 bytes)!"))},self.defer=function(fn,delay){var timeoutId;return outstandingRequestCount++,timeoutId=setTimeout(function(){delete pendingDeferIds[timeoutId],completeOutstandingRequest(fn)},delay||0),pendingDeferIds[timeoutId]=!0,timeoutId},self.defer.cancel=function(deferId){return pendingDeferIds[deferId]?(delete pendingDeferIds[deferId],clearTimeout(deferId),completeOutstandingRequest(noop),!0):!1}}function $BrowserProvider(){this.$get=["$window","$log","$sniffer","$document",function($window,$log,$sniffer,$document){return new Browser($window,$document,$log,$sniffer)}]}function $CacheFactoryProvider(){this.$get=function(){function cacheFactory(cacheId,options){function refresh(entry){entry!=freshEnd&&(staleEnd?staleEnd==entry&&(staleEnd=entry.n):staleEnd=entry,link(entry.n,entry.p),link(entry,freshEnd),freshEnd=entry,freshEnd.n=null)}function link(nextEntry,prevEntry){nextEntry!=prevEntry&&(nextEntry&&(nextEntry.p=prevEntry),prevEntry&&(prevEntry.n=nextEntry))}if(cacheId in caches)throw Error("cacheId "+cacheId+" taken");var size=0,stats=extend({},options,{id:cacheId}),data={},capacity=options&&options.capacity||Number.MAX_VALUE,lruHash={},freshEnd=null,staleEnd=null;return caches[cacheId]={put:function(key,value){var lruEntry=lruHash[key]||(lruHash[key]={key:key});refresh(lruEntry),isUndefined(value)||(key in data||size++,data[key]=value,size>capacity&&this.remove(staleEnd.key))},get:function(key){var lruEntry=lruHash[key];if(lruEntry)return refresh(lruEntry),data[key]},remove:function(key){var lruEntry=lruHash[key];lruEntry&&(lruEntry==freshEnd&&(freshEnd=lruEntry.p),lruEntry==staleEnd&&(staleEnd=lruEntry.n),link(lruEntry.n,lruEntry.p),delete lruHash[key],delete data[key],size--)},removeAll:function(){data={},size=0,lruHash={},freshEnd=staleEnd=null},destroy:function(){data=null,stats=null,lruHash=null,delete caches[cacheId]},info:function(){return extend({},stats,{size:size})}}}var caches={};return cacheFactory.info=function(){var info={};return forEach(caches,function(cache,cacheId){info[cacheId]=cache.info()}),info},cacheFactory.get=function(cacheId){return caches[cacheId]},cacheFactory}}function $TemplateCacheProvider(){this.$get=["$cacheFactory",function($cacheFactory){return $cacheFactory("templates")}]}function $CompileProvider($provide){var hasDirectives={},Suffix="Directive",COMMENT_DIRECTIVE_REGEXP=/^\s*directive\:\s*([\d\w\-_]+)\s+(.*)$/,CLASS_DIRECTIVE_REGEXP=/(([\d\w\-_]+)(?:\:([^;]+))?;?)/,MULTI_ROOT_TEMPLATE_ERROR="Template must have exactly one root element. was: ",urlSanitizationWhitelist=/^\s*(https?|ftp|mailto|file):/;this.directive=function registerDirective(name,directiveFactory){return isString(name)?(assertArg(directiveFactory,"directive"),hasDirectives.hasOwnProperty(name)||(hasDirectives[name]=[],$provide.factory(name+Suffix,["$injector","$exceptionHandler",function($injector,$exceptionHandler){var directives=[];return forEach(hasDirectives[name],function(directiveFactory){try{var directive=$injector.invoke(directiveFactory);isFunction(directive)?directive={compile:valueFn(directive)}:!directive.compile&&directive.link&&(directive.compile=valueFn(directive.link)),directive.priority=directive.priority||0,directive.name=directive.name||name,directive.require=directive.require||directive.controller&&directive.name,directive.restrict=directive.restrict||"A",directives.push(directive)}catch(e){$exceptionHandler(e)}}),directives}])),hasDirectives[name].push(directiveFactory)):forEach(name,reverseParams(registerDirective)),this},this.urlSanitizationWhitelist=function(regexp){return isDefined(regexp)?(urlSanitizationWhitelist=regexp,this):urlSanitizationWhitelist},this.$get=["$injector","$interpolate","$exceptionHandler","$http","$templateCache","$parse","$controller","$rootScope","$document",function($injector,$interpolate,$exceptionHandler,$http,$templateCache,$parse,$controller,$rootScope,$document){function compile($compileNodes,transcludeFn,maxPriority){$compileNodes instanceof jqLite||($compileNodes=jqLite($compileNodes)),forEach($compileNodes,function(node,index){3==node.nodeType&&node.nodeValue.match(/\S+/)&&($compileNodes[index]=jqLite(node).wrap("<span></span>").parent()[0])
});var compositeLinkFn=compileNodes($compileNodes,transcludeFn,$compileNodes,maxPriority);return function(scope,cloneConnectFn){assertArg(scope,"scope");for(var $linkNode=cloneConnectFn?JQLitePrototype.clone.call($compileNodes):$compileNodes,i=0,ii=$linkNode.length;ii>i;i++){var node=$linkNode[i];(1==node.nodeType||9==node.nodeType)&&$linkNode.eq(i).data("$scope",scope)}return safeAddClass($linkNode,"ng-scope"),cloneConnectFn&&cloneConnectFn($linkNode,scope),compositeLinkFn&&compositeLinkFn(scope,$linkNode,$linkNode),$linkNode}}function safeAddClass($element,className){try{$element.addClass(className)}catch(e){}}function compileNodes(nodeList,transcludeFn,$rootElement,maxPriority){function compositeLinkFn(scope,nodeList,$rootElement,boundTranscludeFn){var nodeLinkFn,childLinkFn,node,childScope,childTranscludeFn,i,ii,n,stableNodeList=[];for(i=0,ii=nodeList.length;ii>i;i++)stableNodeList.push(nodeList[i]);for(i=0,n=0,ii=linkFns.length;ii>i;n++)node=stableNodeList[n],nodeLinkFn=linkFns[i++],childLinkFn=linkFns[i++],nodeLinkFn?(nodeLinkFn.scope?(childScope=scope.$new(isObject(nodeLinkFn.scope)),jqLite(node).data("$scope",childScope)):childScope=scope,childTranscludeFn=nodeLinkFn.transclude,childTranscludeFn||!boundTranscludeFn&&transcludeFn?nodeLinkFn(childLinkFn,childScope,node,$rootElement,function(transcludeFn){return function(cloneFn){var transcludeScope=scope.$new();return transcludeScope.$$transcluded=!0,transcludeFn(transcludeScope,cloneFn).bind("$destroy",bind(transcludeScope,transcludeScope.$destroy))}}(childTranscludeFn||transcludeFn)):nodeLinkFn(childLinkFn,childScope,node,undefined,boundTranscludeFn)):childLinkFn&&childLinkFn(scope,node.childNodes,undefined,boundTranscludeFn)}for(var nodeLinkFn,childLinkFn,directives,attrs,linkFnFound,linkFns=[],i=0;i<nodeList.length;i++)attrs=new Attributes,directives=collectDirectives(nodeList[i],[],attrs,maxPriority),nodeLinkFn=directives.length?applyDirectivesToNode(directives,nodeList[i],attrs,transcludeFn,$rootElement):null,childLinkFn=nodeLinkFn&&nodeLinkFn.terminal||!nodeList[i].childNodes||!nodeList[i].childNodes.length?null:compileNodes(nodeList[i].childNodes,nodeLinkFn?nodeLinkFn.transclude:transcludeFn),linkFns.push(nodeLinkFn),linkFns.push(childLinkFn),linkFnFound=linkFnFound||nodeLinkFn||childLinkFn;return linkFnFound?compositeLinkFn:null}function collectDirectives(node,directives,attrs,maxPriority){var match,className,nodeType=node.nodeType,attrsMap=attrs.$attr;switch(nodeType){case 1:addDirective(directives,directiveNormalize(nodeName_(node).toLowerCase()),"E",maxPriority);for(var attr,name,nName,value,nAttrs=node.attributes,j=0,jj=nAttrs&&nAttrs.length;jj>j;j++)attr=nAttrs[j],(!msie||msie>=8||attr.specified)&&(name=attr.name,nName=directiveNormalize(name.toLowerCase()),attrsMap[nName]=name,attrs[nName]=value=trim(msie&&"href"==name?decodeURIComponent(node.getAttribute(name,2)):attr.value),getBooleanAttrName(node,nName)&&(attrs[nName]=!0),addAttrInterpolateDirective(node,directives,value,nName),addDirective(directives,nName,"A",maxPriority));if(className=node.className,isString(className)&&""!==className)for(;match=CLASS_DIRECTIVE_REGEXP.exec(className);)nName=directiveNormalize(match[2]),addDirective(directives,nName,"C",maxPriority)&&(attrs[nName]=trim(match[3])),className=className.substr(match.index+match[0].length);break;case 3:addTextInterpolateDirective(directives,node.nodeValue);break;case 8:try{match=COMMENT_DIRECTIVE_REGEXP.exec(node.nodeValue),match&&(nName=directiveNormalize(match[1]),addDirective(directives,nName,"M",maxPriority)&&(attrs[nName]=trim(match[2])))}catch(e){}}return directives.sort(byPriority),directives}function applyDirectivesToNode(directives,compileNode,templateAttrs,transcludeFn,jqCollection){function addLinkFns(pre,post){pre&&(pre.require=directive.require,preLinkFns.push(pre)),post&&(post.require=directive.require,postLinkFns.push(post))}function getControllers(require,$element){var value,retrievalMethod="data",optional=!1;if(isString(require)){for(;"^"==(value=require.charAt(0))||"?"==value;)require=require.substr(1),"^"==value&&(retrievalMethod="inheritedData"),optional=optional||"?"==value;if(value=$element[retrievalMethod]("$"+require+"Controller"),!value&&!optional)throw Error("No controller: "+require);return value}return isArray(require)&&(value=[],forEach(require,function(require){value.push(getControllers(require,$element))})),value}function nodeLinkFn(childLinkFn,scope,linkNode,$rootElement,boundTranscludeFn){var attrs,$element,i,ii,linkFn,controller;if(attrs=compileNode===linkNode?templateAttrs:shallowCopy(templateAttrs,new Attributes(jqLite(linkNode),templateAttrs.$attr)),$element=attrs.$$element,newIsolateScopeDirective){var LOCAL_REGEXP=/^\s*([@=&])\s*(\w*)\s*$/,parentScope=scope.$parent||scope;forEach(newIsolateScopeDirective.scope,function(definiton,scopeName){var lastValue,parentGet,parentSet,match=definiton.match(LOCAL_REGEXP)||[],attrName=match[2]||scopeName,mode=match[1];switch(scope.$$isolateBindings[scopeName]=mode+attrName,mode){case"@":attrs.$observe(attrName,function(value){scope[scopeName]=value}),attrs.$$observers[attrName].$$scope=parentScope;break;case"=":parentGet=$parse(attrs[attrName]),parentSet=parentGet.assign||function(){throw lastValue=scope[scopeName]=parentGet(parentScope),Error(NON_ASSIGNABLE_MODEL_EXPRESSION+attrs[attrName]+" (directive: "+newIsolateScopeDirective.name+")")},lastValue=scope[scopeName]=parentGet(parentScope),scope.$watch(function(){var parentValue=parentGet(parentScope);return parentValue!==scope[scopeName]&&(parentValue!==lastValue?lastValue=scope[scopeName]=parentValue:parentSet(parentScope,parentValue=lastValue=scope[scopeName])),parentValue});break;case"&":parentGet=$parse(attrs[attrName]),scope[scopeName]=function(locals){return parentGet(parentScope,locals)};break;default:throw Error("Invalid isolate scope definition for directive "+newIsolateScopeDirective.name+": "+definiton)}})}for(controllerDirectives&&forEach(controllerDirectives,function(directive){var locals={$scope:scope,$element:$element,$attrs:attrs,$transclude:boundTranscludeFn};controller=directive.controller,"@"==controller&&(controller=attrs[directive.name]),$element.data("$"+directive.name+"Controller",$controller(controller,locals))}),i=0,ii=preLinkFns.length;ii>i;i++)try{linkFn=preLinkFns[i],linkFn(scope,$element,attrs,linkFn.require&&getControllers(linkFn.require,$element))}catch(e){$exceptionHandler(e,startingTag($element))}for(childLinkFn&&childLinkFn(scope,linkNode.childNodes,undefined,boundTranscludeFn),i=0,ii=postLinkFns.length;ii>i;i++)try{linkFn=postLinkFns[i],linkFn(scope,$element,attrs,linkFn.require&&getControllers(linkFn.require,$element))}catch(e){$exceptionHandler(e,startingTag($element))}}for(var directive,directiveName,$template,transcludeDirective,controllerDirectives,linkFn,directiveValue,terminalPriority=-Number.MAX_VALUE,preLinkFns=[],postLinkFns=[],newScopeDirective=null,newIsolateScopeDirective=null,templateDirective=null,$compileNode=templateAttrs.$$element=jqLite(compileNode),childTranscludeFn=transcludeFn,i=0,ii=directives.length;ii>i&&(directive=directives[i],$template=undefined,!(terminalPriority>directive.priority));i++){if((directiveValue=directive.scope)&&(assertNoDuplicate("isolated scope",newIsolateScopeDirective,directive,$compileNode),isObject(directiveValue)&&(safeAddClass($compileNode,"ng-isolate-scope"),newIsolateScopeDirective=directive),safeAddClass($compileNode,"ng-scope"),newScopeDirective=newScopeDirective||directive),directiveName=directive.name,(directiveValue=directive.controller)&&(controllerDirectives=controllerDirectives||{},assertNoDuplicate("'"+directiveName+"' controller",controllerDirectives[directiveName],directive,$compileNode),controllerDirectives[directiveName]=directive),(directiveValue=directive.transclude)&&(assertNoDuplicate("transclusion",transcludeDirective,directive,$compileNode),transcludeDirective=directive,terminalPriority=directive.priority,"element"==directiveValue?($template=jqLite(compileNode),$compileNode=templateAttrs.$$element=jqLite(document.createComment(" "+directiveName+": "+templateAttrs[directiveName]+" ")),compileNode=$compileNode[0],replaceWith(jqCollection,jqLite($template[0]),compileNode),childTranscludeFn=compile($template,transcludeFn,terminalPriority)):($template=jqLite(JQLiteClone(compileNode)).contents(),$compileNode.html(""),childTranscludeFn=compile($template,transcludeFn))),directiveValue=directive.template)if(assertNoDuplicate("template",templateDirective,directive,$compileNode),templateDirective=directive,directiveValue=denormalizeTemplate(directiveValue),directive.replace){if($template=jqLite("<div>"+trim(directiveValue)+"</div>").contents(),compileNode=$template[0],1!=$template.length||1!==compileNode.nodeType)throw new Error(MULTI_ROOT_TEMPLATE_ERROR+directiveValue);replaceWith(jqCollection,$compileNode,compileNode);var newTemplateAttrs={$attr:{}};directives=directives.concat(collectDirectives(compileNode,directives.splice(i+1,directives.length-(i+1)),newTemplateAttrs)),mergeTemplateAttributes(templateAttrs,newTemplateAttrs),ii=directives.length}else $compileNode.html(directiveValue);if(directive.templateUrl)assertNoDuplicate("template",templateDirective,directive,$compileNode),templateDirective=directive,nodeLinkFn=compileTemplateUrl(directives.splice(i,directives.length-i),nodeLinkFn,$compileNode,templateAttrs,jqCollection,directive.replace,childTranscludeFn),ii=directives.length;else if(directive.compile)try{linkFn=directive.compile($compileNode,templateAttrs,childTranscludeFn),isFunction(linkFn)?addLinkFns(null,linkFn):linkFn&&addLinkFns(linkFn.pre,linkFn.post)}catch(e){$exceptionHandler(e,startingTag($compileNode))}directive.terminal&&(nodeLinkFn.terminal=!0,terminalPriority=Math.max(terminalPriority,directive.priority))}return nodeLinkFn.scope=newScopeDirective&&newScopeDirective.scope,nodeLinkFn.transclude=transcludeDirective&&childTranscludeFn,nodeLinkFn}function addDirective(tDirectives,name,location,maxPriority){var match=!1;if(hasDirectives.hasOwnProperty(name))for(var directive,directives=$injector.get(name+Suffix),i=0,ii=directives.length;ii>i;i++)try{directive=directives[i],(maxPriority===undefined||maxPriority>directive.priority)&&-1!=directive.restrict.indexOf(location)&&(tDirectives.push(directive),match=!0)}catch(e){$exceptionHandler(e)}return match}function mergeTemplateAttributes(dst,src){var srcAttr=src.$attr,dstAttr=dst.$attr,$element=dst.$$element;forEach(dst,function(value,key){"$"!=key.charAt(0)&&(src[key]&&(value+=("style"===key?";":" ")+src[key]),dst.$set(key,value,!0,srcAttr[key]))}),forEach(src,function(value,key){"class"==key?(safeAddClass($element,value),dst["class"]=(dst["class"]?dst["class"]+" ":"")+value):"style"==key?$element.attr("style",$element.attr("style")+";"+value):"$"==key.charAt(0)||dst.hasOwnProperty(key)||(dst[key]=value,dstAttr[key]=srcAttr[key])})}function compileTemplateUrl(directives,beforeTemplateNodeLinkFn,$compileNode,tAttrs,$rootElement,replace,childTranscludeFn){var afterTemplateNodeLinkFn,afterTemplateChildLinkFn,linkQueue=[],beforeTemplateCompileNode=$compileNode[0],origAsyncDirective=directives.shift(),derivedSyncDirective=extend({},origAsyncDirective,{controller:null,templateUrl:null,transclude:null,scope:null});return $compileNode.html(""),$http.get(origAsyncDirective.templateUrl,{cache:$templateCache}).success(function(content){var compileNode,tempTemplateAttrs,$template;if(content=denormalizeTemplate(content),replace){if($template=jqLite("<div>"+trim(content)+"</div>").contents(),compileNode=$template[0],1!=$template.length||1!==compileNode.nodeType)throw new Error(MULTI_ROOT_TEMPLATE_ERROR+content);tempTemplateAttrs={$attr:{}},replaceWith($rootElement,$compileNode,compileNode),collectDirectives(compileNode,directives,tempTemplateAttrs),mergeTemplateAttributes(tAttrs,tempTemplateAttrs)}else compileNode=beforeTemplateCompileNode,$compileNode.html(content);for(directives.unshift(derivedSyncDirective),afterTemplateNodeLinkFn=applyDirectivesToNode(directives,compileNode,tAttrs,childTranscludeFn),afterTemplateChildLinkFn=compileNodes($compileNode[0].childNodes,childTranscludeFn);linkQueue.length;){var controller=linkQueue.pop(),linkRootElement=linkQueue.pop(),beforeTemplateLinkNode=linkQueue.pop(),scope=linkQueue.pop(),linkNode=compileNode;beforeTemplateLinkNode!==beforeTemplateCompileNode&&(linkNode=JQLiteClone(compileNode),replaceWith(linkRootElement,jqLite(beforeTemplateLinkNode),linkNode)),afterTemplateNodeLinkFn(function(){beforeTemplateNodeLinkFn(afterTemplateChildLinkFn,scope,linkNode,$rootElement,controller)},scope,linkNode,$rootElement,controller)}linkQueue=null}).error(function(response,code,headers,config){throw Error("Failed to load template: "+config.url)}),function(ignoreChildLinkFn,scope,node,rootElement,controller){linkQueue?(linkQueue.push(scope),linkQueue.push(node),linkQueue.push(rootElement),linkQueue.push(controller)):afterTemplateNodeLinkFn(function(){beforeTemplateNodeLinkFn(afterTemplateChildLinkFn,scope,node,rootElement,controller)},scope,node,rootElement,controller)}}function byPriority(a,b){return b.priority-a.priority}function assertNoDuplicate(what,previousDirective,directive,element){if(previousDirective)throw Error("Multiple directives ["+previousDirective.name+", "+directive.name+"] asking for "+what+" on: "+startingTag(element))}function addTextInterpolateDirective(directives,text){var interpolateFn=$interpolate(text,!0);interpolateFn&&directives.push({priority:0,compile:valueFn(function(scope,node){var parent=node.parent(),bindings=parent.data("$binding")||[];bindings.push(interpolateFn),safeAddClass(parent.data("$binding",bindings),"ng-binding"),scope.$watch(interpolateFn,function(value){node[0].nodeValue=value})})})}function addAttrInterpolateDirective(node,directives,value,name){var interpolateFn=$interpolate(value,!0);interpolateFn&&directives.push({priority:100,compile:valueFn(function(scope,element,attr){var $$observers=attr.$$observers||(attr.$$observers={});"class"===name&&(interpolateFn=$interpolate(attr[name],!0)),attr[name]=undefined,($$observers[name]||($$observers[name]=[])).$$inter=!0,(attr.$$observers&&attr.$$observers[name].$$scope||scope).$watch(interpolateFn,function(value){attr.$set(name,value)})})})}function replaceWith($rootElement,$element,newNode){var i,ii,oldNode=$element[0],parent=oldNode.parentNode;if($rootElement)for(i=0,ii=$rootElement.length;ii>i;i++)if($rootElement[i]==oldNode){$rootElement[i]=newNode;break}parent&&parent.replaceChild(newNode,oldNode),newNode[jqLite.expando]=oldNode[jqLite.expando],$element[0]=newNode}var Attributes=function(element,attr){this.$$element=element,this.$attr=attr||{}};Attributes.prototype={$normalize:directiveNormalize,$set:function(key,value,writeAttr,attrName){var normalizedVal,booleanKey=getBooleanAttrName(this.$$element[0],key),$$observers=this.$$observers;booleanKey&&(this.$$element.prop(key,value),attrName=booleanKey),this[key]=value,attrName?this.$attr[key]=attrName:(attrName=this.$attr[key],attrName||(this.$attr[key]=attrName=snake_case(key,"-"))),"A"===nodeName_(this.$$element[0])&&"href"===key&&(urlSanitizationNode.setAttribute("href",value),normalizedVal=urlSanitizationNode.href,""===normalizedVal||normalizedVal.match(urlSanitizationWhitelist)||(this[key]=value="unsafe:"+normalizedVal)),writeAttr!==!1&&(null===value||value===undefined?this.$$element.removeAttr(attrName):this.$$element.attr(attrName,value)),$$observers&&forEach($$observers[key],function(fn){try{fn(value)}catch(e){$exceptionHandler(e)}})},$observe:function(key,fn){var attrs=this,$$observers=attrs.$$observers||(attrs.$$observers={}),listeners=$$observers[key]||($$observers[key]=[]);return listeners.push(fn),$rootScope.$evalAsync(function(){listeners.$$inter||fn(attrs[key])}),fn}};var urlSanitizationNode=$document[0].createElement("a"),startSymbol=$interpolate.startSymbol(),endSymbol=$interpolate.endSymbol(),denormalizeTemplate="{{"==startSymbol||"}}"==endSymbol?identity:function(template){return template.replace(/\{\{/g,startSymbol).replace(/}}/g,endSymbol)};return compile}]}function directiveNormalize(name){return camelCase(name.replace(PREFIX_REGEXP,""))}function $ControllerProvider(){var controllers={};this.register=function(name,constructor){isObject(name)?extend(controllers,name):controllers[name]=constructor},this.$get=["$injector","$window",function($injector,$window){return function(constructor,locals){if(isString(constructor)){var name=constructor;constructor=controllers.hasOwnProperty(name)?controllers[name]:getter(locals.$scope,name,!0)||getter($window,name,!0),assertArgFn(constructor,name,!0)}return $injector.instantiate(constructor,locals)}}]}function $DocumentProvider(){this.$get=["$window",function(window){return jqLite(window.document)}]}function $ExceptionHandlerProvider(){this.$get=["$log",function($log){return function(){$log.error.apply($log,arguments)}}]}function $InterpolateProvider(){var startSymbol="{{",endSymbol="}}";this.startSymbol=function(value){return value?(startSymbol=value,this):startSymbol},this.endSymbol=function(value){return value?(endSymbol=value,this):endSymbol},this.$get=["$parse",function($parse){function $interpolate(text,mustHaveExpression){for(var startIndex,endIndex,fn,exp,index=0,parts=[],length=text.length,hasInterpolation=!1,concat=[];length>index;)-1!=(startIndex=text.indexOf(startSymbol,index))&&-1!=(endIndex=text.indexOf(endSymbol,startIndex+startSymbolLength))?(index!=startIndex&&parts.push(text.substring(index,startIndex)),parts.push(fn=$parse(exp=text.substring(startIndex+startSymbolLength,endIndex))),fn.exp=exp,index=endIndex+endSymbolLength,hasInterpolation=!0):(index!=length&&parts.push(text.substring(index)),index=length);return(length=parts.length)||(parts.push(""),length=1),!mustHaveExpression||hasInterpolation?(concat.length=length,fn=function(context){for(var part,i=0,ii=length;ii>i;i++)"function"==typeof(part=parts[i])&&(part=part(context),null==part||part==undefined?part="":"string"!=typeof part&&(part=toJson(part))),concat[i]=part;return concat.join("")},fn.exp=text,fn.parts=parts,fn):void 0}var startSymbolLength=startSymbol.length,endSymbolLength=endSymbol.length;return $interpolate.startSymbol=function(){return startSymbol},$interpolate.endSymbol=function(){return endSymbol},$interpolate}]}function encodePath(path){for(var segments=path.split("/"),i=segments.length;i--;)segments[i]=encodeUriSegment(segments[i]);return segments.join("/")}function matchUrl(url,obj){var match=URL_MATCH.exec(url);return match={protocol:match[1],host:match[3],port:int(match[5])||DEFAULT_PORTS[match[1]]||null,path:match[6]||"/",search:match[8],hash:match[10]},obj&&(obj.$$protocol=match.protocol,obj.$$host=match.host,obj.$$port=match.port),match}function composeProtocolHostPort(protocol,host,port){return protocol+"://"+host+(port==DEFAULT_PORTS[protocol]?"":":"+port)}function pathPrefixFromBase(basePath){return basePath.substr(0,basePath.lastIndexOf("/"))}function convertToHtml5Url(url,basePath,hashPrefix){var match=matchUrl(url);return decodeURIComponent(match.path)!=basePath||isUndefined(match.hash)||0!==match.hash.indexOf(hashPrefix)?url:composeProtocolHostPort(match.protocol,match.host,match.port)+pathPrefixFromBase(basePath)+match.hash.substr(hashPrefix.length)}function convertToHashbangUrl(url,basePath,hashPrefix){var match=matchUrl(url);if(decodeURIComponent(match.path)!=basePath||isUndefined(match.hash)||0!==match.hash.indexOf(hashPrefix)){var search=match.search&&"?"+match.search||"",hash=match.hash&&"#"+match.hash||"",pathPrefix=pathPrefixFromBase(basePath),path=match.path.substr(pathPrefix.length);if(0!==match.path.indexOf(pathPrefix))throw Error('Invalid url "'+url+'", missing path prefix "'+pathPrefix+'" !');return composeProtocolHostPort(match.protocol,match.host,match.port)+basePath+"#"+hashPrefix+path+search+hash}return url}function LocationUrl(url,pathPrefix,appBaseUrl){pathPrefix=pathPrefix||"",this.$$parse=function(newAbsoluteUrl){var match=matchUrl(newAbsoluteUrl,this);if(0!==match.path.indexOf(pathPrefix))throw Error('Invalid url "'+newAbsoluteUrl+'", missing path prefix "'+pathPrefix+'" !');this.$$path=decodeURIComponent(match.path.substr(pathPrefix.length)),this.$$search=parseKeyValue(match.search),this.$$hash=match.hash&&decodeURIComponent(match.hash)||"",this.$$compose()},this.$$compose=function(){var search=toKeyValue(this.$$search),hash=this.$$hash?"#"+encodeUriSegment(this.$$hash):"";this.$$url=encodePath(this.$$path)+(search?"?"+search:"")+hash,this.$$absUrl=composeProtocolHostPort(this.$$protocol,this.$$host,this.$$port)+pathPrefix+this.$$url},this.$$rewriteAppUrl=function(absoluteLinkUrl){return 0==absoluteLinkUrl.indexOf(appBaseUrl)?absoluteLinkUrl:void 0},this.$$parse(url)}function LocationHashbangUrl(url,hashPrefix,appBaseUrl){var basePath;this.$$parse=function(url){var match=matchUrl(url,this);if(match.hash&&0!==match.hash.indexOf(hashPrefix))throw Error('Invalid url "'+url+'", missing hash prefix "'+hashPrefix+'" !');basePath=match.path+(match.search?"?"+match.search:""),match=HASH_MATCH.exec((match.hash||"").substr(hashPrefix.length)),this.$$path=match[1]?("/"==match[1].charAt(0)?"":"/")+decodeURIComponent(match[1]):"",this.$$search=parseKeyValue(match[3]),this.$$hash=match[5]&&decodeURIComponent(match[5])||"",this.$$compose()},this.$$compose=function(){var search=toKeyValue(this.$$search),hash=this.$$hash?"#"+encodeUriSegment(this.$$hash):"";this.$$url=encodePath(this.$$path)+(search?"?"+search:"")+hash,this.$$absUrl=composeProtocolHostPort(this.$$protocol,this.$$host,this.$$port)+basePath+(this.$$url?"#"+hashPrefix+this.$$url:"")},this.$$rewriteAppUrl=function(absoluteLinkUrl){return 0==absoluteLinkUrl.indexOf(appBaseUrl)?absoluteLinkUrl:void 0},this.$$parse(url)}function LocationHashbangInHtml5Url(url,hashPrefix,appBaseUrl,baseExtra){LocationHashbangUrl.apply(this,arguments),this.$$rewriteAppUrl=function(absoluteLinkUrl){return 0==absoluteLinkUrl.indexOf(appBaseUrl)?appBaseUrl+baseExtra+"#"+hashPrefix+absoluteLinkUrl.substr(appBaseUrl.length):void 0}}function locationGetter(property){return function(){return this[property]}}function locationGetterSetter(property,preprocess){return function(value){return isUndefined(value)?this[property]:(this[property]=preprocess(value),this.$$compose(),this)}}function $LocationProvider(){var hashPrefix="",html5Mode=!1;this.hashPrefix=function(prefix){return isDefined(prefix)?(hashPrefix=prefix,this):hashPrefix},this.html5Mode=function(mode){return isDefined(mode)?(html5Mode=mode,this):html5Mode},this.$get=["$rootScope","$browser","$sniffer","$rootElement",function($rootScope,$browser,$sniffer,$rootElement){function afterLocationChange(oldUrl){$rootScope.$broadcast("$locationChangeSuccess",$location.absUrl(),oldUrl)}var $location,basePath,pathPrefix,appBaseUrl,initUrl=$browser.url(),initUrlParts=matchUrl(initUrl);html5Mode?(basePath=$browser.baseHref()||"/",pathPrefix=pathPrefixFromBase(basePath),appBaseUrl=composeProtocolHostPort(initUrlParts.protocol,initUrlParts.host,initUrlParts.port)+pathPrefix+"/",$location=$sniffer.history?new LocationUrl(convertToHtml5Url(initUrl,basePath,hashPrefix),pathPrefix,appBaseUrl):new LocationHashbangInHtml5Url(convertToHashbangUrl(initUrl,basePath,hashPrefix),hashPrefix,appBaseUrl,basePath.substr(pathPrefix.length+1))):(appBaseUrl=composeProtocolHostPort(initUrlParts.protocol,initUrlParts.host,initUrlParts.port)+(initUrlParts.path||"")+(initUrlParts.search?"?"+initUrlParts.search:"")+"#"+hashPrefix+"/",$location=new LocationHashbangUrl(initUrl,hashPrefix,appBaseUrl)),$rootElement.bind("click",function(event){if(!event.ctrlKey&&!event.metaKey&&2!=event.which){for(var elm=jqLite(event.target);"a"!==lowercase(elm[0].nodeName);)if(elm[0]===$rootElement[0]||!(elm=elm.parent())[0])return;var absHref=elm.prop("href"),rewrittenUrl=$location.$$rewriteAppUrl(absHref);absHref&&!elm.attr("target")&&rewrittenUrl&&($location.$$parse(rewrittenUrl),$rootScope.$apply(),event.preventDefault(),window.angular["ff-684208-preventDefault"]=!0)}}),$location.absUrl()!=initUrl&&$browser.url($location.absUrl(),!0),$browser.onUrlChange(function(newUrl){if($location.absUrl()!=newUrl){if($rootScope.$broadcast("$locationChangeStart",newUrl,$location.absUrl()).defaultPrevented)return $browser.url($location.absUrl()),void 0;$rootScope.$evalAsync(function(){var oldUrl=$location.absUrl();$location.$$parse(newUrl),afterLocationChange(oldUrl)}),$rootScope.$$phase||$rootScope.$digest()}});var changeCounter=0;return $rootScope.$watch(function(){var oldUrl=$browser.url(),currentReplace=$location.$$replace;return changeCounter&&oldUrl==$location.absUrl()||(changeCounter++,$rootScope.$evalAsync(function(){$rootScope.$broadcast("$locationChangeStart",$location.absUrl(),oldUrl).defaultPrevented?$location.$$parse(oldUrl):($browser.url($location.absUrl(),currentReplace),afterLocationChange(oldUrl))})),$location.$$replace=!1,changeCounter}),$location}]}function $LogProvider(){this.$get=["$window",function($window){function formatError(arg){return arg instanceof Error&&(arg.stack?arg=arg.message&&-1===arg.stack.indexOf(arg.message)?"Error: "+arg.message+"\n"+arg.stack:arg.stack:arg.sourceURL&&(arg=arg.message+"\n"+arg.sourceURL+":"+arg.line)),arg}function consoleLog(type){var console=$window.console||{},logFn=console[type]||console.log||noop;return logFn.apply?function(){var args=[];return forEach(arguments,function(arg){args.push(formatError(arg))}),logFn.apply(console,args)}:function(arg1,arg2){logFn(arg1,arg2)}}return{log:consoleLog("log"),warn:consoleLog("warn"),info:consoleLog("info"),error:consoleLog("error")}}]}function lex(text,csp){function is(chars){return-1!=chars.indexOf(ch)}function was(chars){return-1!=chars.indexOf(lastCh)}function peek(){return index+1<text.length?text.charAt(index+1):!1}function isNumber(ch){return ch>="0"&&"9">=ch}function isWhitespace(ch){return" "==ch||"\r"==ch||"	"==ch||"\n"==ch||""==ch||" "==ch}function isIdent(ch){return ch>="a"&&"z">=ch||ch>="A"&&"Z">=ch||"_"==ch||"$"==ch}function isExpOperator(ch){return"-"==ch||"+"==ch||isNumber(ch)}function throwError(error,start,end){throw end=end||index,Error("Lexer Error: "+error+" at column"+(isDefined(start)?"s "+start+"-"+index+" ["+text.substring(start,end)+"]":" "+end)+" in expression ["+text+"].")}function readNumber(){for(var number="",start=index;index<text.length;){var ch=lowercase(text.charAt(index));if("."==ch||isNumber(ch))number+=ch;else{var peekCh=peek();if("e"==ch&&isExpOperator(peekCh))number+=ch;else if(isExpOperator(ch)&&peekCh&&isNumber(peekCh)&&"e"==number.charAt(number.length-1))number+=ch;else{if(!isExpOperator(ch)||peekCh&&isNumber(peekCh)||"e"!=number.charAt(number.length-1))break;throwError("Invalid exponent")}}index++}number=1*number,tokens.push({index:start,text:number,json:!0,fn:function(){return number}})}function readIdent(){for(var lastDot,peekIndex,methodName,ch,ident="",start=index;index<text.length&&(ch=text.charAt(index),"."==ch||isIdent(ch)||isNumber(ch));)"."==ch&&(lastDot=index),ident+=ch,index++;if(lastDot)for(peekIndex=index;peekIndex<text.length;){if(ch=text.charAt(peekIndex),"("==ch){methodName=ident.substr(lastDot-start+1),ident=ident.substr(0,lastDot-start),index=peekIndex;break}if(!isWhitespace(ch))break;peekIndex++}var token={index:start,text:ident};if(OPERATORS.hasOwnProperty(ident))token.fn=token.json=OPERATORS[ident];else{var getter=getterFn(ident,csp);token.fn=extend(function(self,locals){return getter(self,locals)},{assign:function(self,value){return setter(self,ident,value)}})}tokens.push(token),methodName&&(tokens.push({index:lastDot,text:".",json:!1}),tokens.push({index:lastDot+1,text:methodName,json:!1}))}function readString(quote){var start=index;index++;for(var string="",rawString=quote,escape=!1;index<text.length;){var ch=text.charAt(index);if(rawString+=ch,escape){if("u"==ch){var hex=text.substring(index+1,index+5);hex.match(/[\da-f]{4}/i)||throwError("Invalid unicode escape [\\u"+hex+"]"),index+=4,string+=String.fromCharCode(parseInt(hex,16))}else{var rep=ESCAPE[ch];string+=rep?rep:ch}escape=!1}else if("\\"==ch)escape=!0;else{if(ch==quote)return index++,tokens.push({index:start,text:rawString,string:string,json:!0,fn:function(){return string}}),void 0;string+=ch}index++}throwError("Unterminated quote",start)}for(var token,ch,tokens=[],index=0,json=[],lastCh=":";index<text.length;){if(ch=text.charAt(index),is("\"'"))readString(ch);else if(isNumber(ch)||is(".")&&isNumber(peek()))readNumber();else if(isIdent(ch))readIdent(),was("{,")&&"{"==json[0]&&(token=tokens[tokens.length-1])&&(token.json=-1==token.text.indexOf("."));else if(is("(){}[].,;:"))tokens.push({index:index,text:ch,json:was(":[,")&&is("{[")||is("}]:,")}),is("{[")&&json.unshift(ch),is("}]")&&json.shift(),index++;else{if(isWhitespace(ch)){index++;continue}var ch2=ch+peek(),fn=OPERATORS[ch],fn2=OPERATORS[ch2];fn2?(tokens.push({index:index,text:ch2,fn:fn2}),index+=2):fn?(tokens.push({index:index,text:ch,fn:fn,json:was("[,:")&&is("+-")}),index+=1):throwError("Unexpected next character ",index,index+1)}lastCh=ch}return tokens}function parser(text,json,$filter,csp){function throwError(msg,token){throw Error("Syntax Error: Token '"+token.text+"' "+msg+" at column "+(token.index+1)+" of the expression ["+text+"] starting at ["+text.substring(token.index)+"].")}function peekToken(){if(0===tokens.length)throw Error("Unexpected end of expression: "+text);return tokens[0]}function peek(e1,e2,e3,e4){if(tokens.length>0){var token=tokens[0],t=token.text;if(t==e1||t==e2||t==e3||t==e4||!e1&&!e2&&!e3&&!e4)return token}return!1}function expect(e1,e2,e3,e4){var token=peek(e1,e2,e3,e4);return token?(json&&!token.json&&throwError("is not valid json",token),tokens.shift(),token):!1}function consume(e1){expect(e1)||throwError("is unexpected, expecting ["+e1+"]",peek())}function unaryFn(fn,right){return function(self,locals){return fn(self,locals,right)}}function binaryFn(left,fn,right){return function(self,locals){return fn(self,locals,left,right)}}function statements(){for(var statements=[];;)if(tokens.length>0&&!peek("}",")",";","]")&&statements.push(filterChain()),!expect(";"))return 1==statements.length?statements[0]:function(self,locals){for(var value,i=0;i<statements.length;i++){var statement=statements[i];statement&&(value=statement(self,locals))}return value}}function _filterChain(){for(var token,left=expression();;){if(!(token=expect("|")))return left;left=binaryFn(left,token.fn,filter())}}function filter(){for(var token=expect(),fn=$filter(token.text),argsFn=[];;){if(!(token=expect(":"))){var fnInvoke=function(self,locals,input){for(var args=[input],i=0;i<argsFn.length;i++)args.push(argsFn[i](self,locals));return fn.apply(self,args)};return function(){return fnInvoke}}argsFn.push(expression())}}function expression(){return assignment()}function _assignment(){var right,token,left=logicalOR();return(token=expect("="))?(left.assign||throwError("implies assignment but ["+text.substring(0,token.index)+"] can not be assigned to",token),right=logicalOR(),function(scope,locals){return left.assign(scope,right(scope,locals),locals)}):left}function logicalOR(){for(var token,left=logicalAND();;){if(!(token=expect("||")))return left;left=binaryFn(left,token.fn,logicalAND())}}function logicalAND(){var token,left=equality();return(token=expect("&&"))&&(left=binaryFn(left,token.fn,logicalAND())),left}function equality(){var token,left=relational();return(token=expect("==","!="))&&(left=binaryFn(left,token.fn,equality())),left}function relational(){var token,left=additive();return(token=expect("<",">","<=",">="))&&(left=binaryFn(left,token.fn,relational())),left}function additive(){for(var token,left=multiplicative();token=expect("+","-");)left=binaryFn(left,token.fn,multiplicative());return left}function multiplicative(){for(var token,left=unary();token=expect("*","/","%");)left=binaryFn(left,token.fn,unary());return left}function unary(){var token;return expect("+")?primary():(token=expect("-"))?binaryFn(ZERO,token.fn,unary()):(token=expect("!"))?unaryFn(token.fn,unary()):primary()
}function primary(){var primary;if(expect("("))primary=filterChain(),consume(")");else if(expect("["))primary=arrayDeclaration();else if(expect("{"))primary=object();else{var token=expect();primary=token.fn,primary||throwError("not a primary expression",token)}for(var next,context;next=expect("(","[",".");)"("===next.text?(primary=functionCall(primary,context),context=null):"["===next.text?(context=primary,primary=objectIndex(primary)):"."===next.text?(context=primary,primary=fieldAccess(primary)):throwError("IMPOSSIBLE");return primary}function _fieldAccess(object){var field=expect().text,getter=getterFn(field,csp);return extend(function(scope,locals,self){return getter(self||object(scope,locals),locals)},{assign:function(scope,value,locals){return setter(object(scope,locals),field,value)}})}function _objectIndex(obj){var indexFn=expression();return consume("]"),extend(function(self,locals){var v,p,o=obj(self,locals),i=indexFn(self,locals);return o?(v=o[i],v&&v.then&&(p=v,"$$v"in v||(p.$$v=undefined,p.then(function(val){p.$$v=val})),v=v.$$v),v):undefined},{assign:function(self,value,locals){return obj(self,locals)[indexFn(self,locals)]=value}})}function _functionCall(fn,contextGetter){var argsFn=[];if(")"!=peekToken().text)do argsFn.push(expression());while(expect(","));return consume(")"),function(scope,locals){for(var args=[],context=contextGetter?contextGetter(scope,locals):scope,i=0;i<argsFn.length;i++)args.push(argsFn[i](scope,locals));var fnPtr=fn(scope,locals,context)||noop;return fnPtr.apply?fnPtr.apply(context,args):fnPtr(args[0],args[1],args[2],args[3],args[4])}}function arrayDeclaration(){var elementFns=[];if("]"!=peekToken().text)do elementFns.push(expression());while(expect(","));return consume("]"),function(self,locals){for(var array=[],i=0;i<elementFns.length;i++)array.push(elementFns[i](self,locals));return array}}function object(){var keyValues=[];if("}"!=peekToken().text)do{var token=expect(),key=token.string||token.text;consume(":");var value=expression();keyValues.push({key:key,value:value})}while(expect(","));return consume("}"),function(self,locals){for(var object={},i=0;i<keyValues.length;i++){var keyValue=keyValues[i];object[keyValue.key]=keyValue.value(self,locals)}return object}}var value,ZERO=valueFn(0),tokens=lex(text,csp),assignment=_assignment,functionCall=_functionCall,fieldAccess=_fieldAccess,objectIndex=_objectIndex,filterChain=_filterChain;return json?(assignment=logicalOR,functionCall=fieldAccess=objectIndex=filterChain=function(){throwError("is not valid json",{text:text,index:0})},value=primary()):value=statements(),0!==tokens.length&&throwError("is an unexpected token",tokens[0]),value}function setter(obj,path,setValue){for(var element=path.split("."),i=0;element.length>1;i++){var key=element.shift(),propertyObj=obj[key];propertyObj||(propertyObj={},obj[key]=propertyObj),obj=propertyObj}return obj[element.shift()]=setValue,setValue}function cspSafeGetterFn(key0,key1,key2,key3,key4){return function(scope,locals){var promise,pathVal=locals&&locals.hasOwnProperty(key0)?locals:scope;return null===pathVal||pathVal===undefined?pathVal:(pathVal=pathVal[key0],pathVal&&pathVal.then&&("$$v"in pathVal||(promise=pathVal,promise.$$v=undefined,promise.then(function(val){promise.$$v=val})),pathVal=pathVal.$$v),key1&&null!==pathVal&&pathVal!==undefined?(pathVal=pathVal[key1],pathVal&&pathVal.then&&("$$v"in pathVal||(promise=pathVal,promise.$$v=undefined,promise.then(function(val){promise.$$v=val})),pathVal=pathVal.$$v),key2&&null!==pathVal&&pathVal!==undefined?(pathVal=pathVal[key2],pathVal&&pathVal.then&&("$$v"in pathVal||(promise=pathVal,promise.$$v=undefined,promise.then(function(val){promise.$$v=val})),pathVal=pathVal.$$v),key3&&null!==pathVal&&pathVal!==undefined?(pathVal=pathVal[key3],pathVal&&pathVal.then&&("$$v"in pathVal||(promise=pathVal,promise.$$v=undefined,promise.then(function(val){promise.$$v=val})),pathVal=pathVal.$$v),key4&&null!==pathVal&&pathVal!==undefined?(pathVal=pathVal[key4],pathVal&&pathVal.then&&("$$v"in pathVal||(promise=pathVal,promise.$$v=undefined,promise.then(function(val){promise.$$v=val})),pathVal=pathVal.$$v),pathVal):pathVal):pathVal):pathVal):pathVal)}}function getterFn(path,csp){if(getterFnCache.hasOwnProperty(path))return getterFnCache[path];var fn,pathKeys=path.split("."),pathKeysLength=pathKeys.length;if(csp)fn=6>pathKeysLength?cspSafeGetterFn(pathKeys[0],pathKeys[1],pathKeys[2],pathKeys[3],pathKeys[4]):function(scope,locals){var val,i=0;do val=cspSafeGetterFn(pathKeys[i++],pathKeys[i++],pathKeys[i++],pathKeys[i++],pathKeys[i++])(scope,locals),locals=undefined,scope=val;while(pathKeysLength>i);return val};else{var code="var l, fn, p;\n";forEach(pathKeys,function(key,index){code+="if(s === null || s === undefined) return s;\nl=s;\ns="+(index?"s":'((k&&k.hasOwnProperty("'+key+'"))?k:s)')+'["'+key+'"]'+";\n"+"if (s && s.then) {\n"+' if (!("$$v" in s)) {\n'+" p=s;\n"+" p.$$v = undefined;\n"+" p.then(function(v) {p.$$v=v;});\n"+"}\n"+" s=s.$$v\n"+"}\n"}),code+="return s;",fn=Function("s","k",code),fn.toString=function(){return code}}return getterFnCache[path]=fn}function $ParseProvider(){var cache={};this.$get=["$filter","$sniffer",function($filter,$sniffer){return function(exp){switch(typeof exp){case"string":return cache.hasOwnProperty(exp)?cache[exp]:cache[exp]=parser(exp,!1,$filter,$sniffer.csp);case"function":return exp;default:return noop}}}]}function $QProvider(){this.$get=["$rootScope","$exceptionHandler",function($rootScope,$exceptionHandler){return qFactory(function(callback){$rootScope.$evalAsync(callback)},$exceptionHandler)}]}function qFactory(nextTick,exceptionHandler){function defaultCallback(value){return value}function defaultErrback(reason){return reject(reason)}function all(promises){var deferred=defer(),counter=promises.length,results=[];return counter?forEach(promises,function(promise,index){ref(promise).then(function(value){index in results||(results[index]=value,--counter||deferred.resolve(results))},function(reason){index in results||deferred.reject(reason)})}):deferred.resolve(results),deferred.promise}var defer=function(){var value,deferred,pending=[];return deferred={resolve:function(val){if(pending){var callbacks=pending;pending=undefined,value=ref(val),callbacks.length&&nextTick(function(){for(var callback,i=0,ii=callbacks.length;ii>i;i++)callback=callbacks[i],value.then(callback[0],callback[1])})}},reject:function(reason){deferred.resolve(reject(reason))},promise:{then:function(callback,errback){var result=defer(),wrappedCallback=function(value){try{result.resolve((callback||defaultCallback)(value))}catch(e){result.reject(e),exceptionHandler(e)}},wrappedErrback=function(reason){try{result.resolve((errback||defaultErrback)(reason))}catch(e){result.reject(e),exceptionHandler(e)}};return pending?pending.push([wrappedCallback,wrappedErrback]):value.then(wrappedCallback,wrappedErrback),result.promise}}}},ref=function(value){return value&&value.then?value:{then:function(callback){var result=defer();return nextTick(function(){result.resolve(callback(value))}),result.promise}}},reject=function(reason){return{then:function(callback,errback){var result=defer();return nextTick(function(){result.resolve((errback||defaultErrback)(reason))}),result.promise}}},when=function(value,callback,errback){var done,result=defer(),wrappedCallback=function(value){try{return(callback||defaultCallback)(value)}catch(e){return exceptionHandler(e),reject(e)}},wrappedErrback=function(reason){try{return(errback||defaultErrback)(reason)}catch(e){return exceptionHandler(e),reject(e)}};return nextTick(function(){ref(value).then(function(value){done||(done=!0,result.resolve(ref(value).then(wrappedCallback,wrappedErrback)))},function(reason){done||(done=!0,result.resolve(wrappedErrback(reason)))})}),result.promise};return{defer:defer,reject:reject,when:when,all:all}}function $RouteProvider(){var routes={};this.when=function(path,route){if(routes[path]=extend({reloadOnSearch:!0},route),path){var redirectPath="/"==path[path.length-1]?path.substr(0,path.length-1):path+"/";routes[redirectPath]={redirectTo:path}}return this},this.otherwise=function(params){return this.when(null,params),this},this.$get=["$rootScope","$location","$routeParams","$q","$injector","$http","$templateCache",function($rootScope,$location,$routeParams,$q,$injector,$http,$templateCache){function switchRouteMatcher(on,when){when="^"+when.replace(/[-\/\\^$*+?.()|[\]{}]/g,"\\$&")+"$";for(var paramMatch,regex="",params=[],dst={},re=/:(\w+)/g,lastMatchedIndex=0;null!==(paramMatch=re.exec(when));)regex+=when.slice(lastMatchedIndex,paramMatch.index),regex+="([^\\/]*)",params.push(paramMatch[1]),lastMatchedIndex=re.lastIndex;regex+=when.substr(lastMatchedIndex);var match=on.match(new RegExp(regex));return match&&forEach(params,function(name,index){dst[name]=match[index+1]}),match?dst:null}function updateRoute(){var next=parseRoute(),last=$route.current;next&&last&&next.$$route===last.$$route&&equals(next.pathParams,last.pathParams)&&!next.reloadOnSearch&&!forceReload?(last.params=next.params,copy(last.params,$routeParams),$rootScope.$broadcast("$routeUpdate",last)):(next||last)&&(forceReload=!1,$rootScope.$broadcast("$routeChangeStart",next,last),$route.current=next,next&&next.redirectTo&&(isString(next.redirectTo)?$location.path(interpolate(next.redirectTo,next.params)).search(next.params).replace():$location.url(next.redirectTo(next.pathParams,$location.path(),$location.search())).replace()),$q.when(next).then(function(){if(next){var template,keys=[],values=[];return forEach(next.resolve||{},function(value,key){keys.push(key),values.push(isString(value)?$injector.get(value):$injector.invoke(value))}),isDefined(template=next.template)||isDefined(template=next.templateUrl)&&(template=$http.get(template,{cache:$templateCache}).then(function(response){return response.data})),isDefined(template)&&(keys.push("$template"),values.push(template)),$q.all(values).then(function(values){var locals={};return forEach(values,function(value,index){locals[keys[index]]=value}),locals})}}).then(function(locals){next==$route.current&&(next&&(next.locals=locals,copy(next.params,$routeParams)),$rootScope.$broadcast("$routeChangeSuccess",next,last))},function(error){next==$route.current&&$rootScope.$broadcast("$routeChangeError",next,last,error)}))}function parseRoute(){var params,match;return forEach(routes,function(route,path){!match&&(params=switchRouteMatcher($location.path(),path))&&(match=inherit(route,{params:extend({},$location.search(),params),pathParams:params}),match.$$route=route)}),match||routes[null]&&inherit(routes[null],{params:{},pathParams:{}})}function interpolate(string,params){var result=[];return forEach((string||"").split(":"),function(segment,i){if(0==i)result.push(segment);else{var segmentMatch=segment.match(/(\w+)(.*)/),key=segmentMatch[1];result.push(params[key]),result.push(segmentMatch[2]||""),delete params[key]}}),result.join("")}var forceReload=!1,$route={routes:routes,reload:function(){forceReload=!0,$rootScope.$evalAsync(updateRoute)}};return $rootScope.$on("$locationChangeSuccess",updateRoute),$route}]}function $RouteParamsProvider(){this.$get=valueFn({})}function $RootScopeProvider(){var TTL=10;this.digestTtl=function(value){return arguments.length&&(TTL=value),TTL},this.$get=["$injector","$exceptionHandler","$parse",function($injector,$exceptionHandler,$parse){function Scope(){this.$id=nextUid(),this.$$phase=this.$parent=this.$$watchers=this.$$nextSibling=this.$$prevSibling=this.$$childHead=this.$$childTail=null,this["this"]=this.$root=this,this.$$destroyed=!1,this.$$asyncQueue=[],this.$$listeners={},this.$$isolateBindings={}}function beginPhase(phase){if($rootScope.$$phase)throw Error($rootScope.$$phase+" already in progress");$rootScope.$$phase=phase}function clearPhase(){$rootScope.$$phase=null}function compileToFn(exp,name){var fn=$parse(exp);return assertArgFn(fn,name),fn}function initWatchVal(){}Scope.prototype={$new:function(isolate){var Child,child;if(isFunction(isolate))throw Error("API-CHANGE: Use $controller to instantiate controllers.");return isolate?(child=new Scope,child.$root=this.$root):(Child=function(){},Child.prototype=this,child=new Child,child.$id=nextUid()),child["this"]=child,child.$$listeners={},child.$parent=this,child.$$asyncQueue=[],child.$$watchers=child.$$nextSibling=child.$$childHead=child.$$childTail=null,child.$$prevSibling=this.$$childTail,this.$$childHead?(this.$$childTail.$$nextSibling=child,this.$$childTail=child):this.$$childHead=this.$$childTail=child,child},$watch:function(watchExp,listener,objectEquality){var scope=this,get=compileToFn(watchExp,"watch"),array=scope.$$watchers,watcher={fn:listener,last:initWatchVal,get:get,exp:watchExp,eq:!!objectEquality};if(!isFunction(listener)){var listenFn=compileToFn(listener||noop,"listener");watcher.fn=function(newVal,oldVal,scope){listenFn(scope)}}return array||(array=scope.$$watchers=[]),array.unshift(watcher),function(){arrayRemove(array,watcher)}},$digest:function(){var watch,value,last,watchers,asyncQueue,length,dirty,next,current,logIdx,logMsg,ttl=TTL,target=this,watchLog=[];beginPhase("$digest");do{dirty=!1,current=target;do{for(asyncQueue=current.$$asyncQueue;asyncQueue.length;)try{current.$eval(asyncQueue.shift())}catch(e){$exceptionHandler(e)}if(watchers=current.$$watchers)for(length=watchers.length;length--;)try{watch=watchers[length],watch&&(value=watch.get(current))!==(last=watch.last)&&!(watch.eq?equals(value,last):"number"==typeof value&&"number"==typeof last&&isNaN(value)&&isNaN(last))&&(dirty=!0,watch.last=watch.eq?copy(value):value,watch.fn(value,last===initWatchVal?value:last,current),5>ttl&&(logIdx=4-ttl,watchLog[logIdx]||(watchLog[logIdx]=[]),logMsg=isFunction(watch.exp)?"fn: "+(watch.exp.name||watch.exp.toString()):watch.exp,logMsg+="; newVal: "+toJson(value)+"; oldVal: "+toJson(last),watchLog[logIdx].push(logMsg)))}catch(e){$exceptionHandler(e)}if(!(next=current.$$childHead||current!==target&&current.$$nextSibling))for(;current!==target&&!(next=current.$$nextSibling);)current=current.$parent}while(current=next);if(dirty&&!ttl--)throw clearPhase(),Error(TTL+" $digest() iterations reached. Aborting!\n"+"Watchers fired in the last 5 iterations: "+toJson(watchLog))}while(dirty||asyncQueue.length);clearPhase()},$destroy:function(){if($rootScope!=this&&!this.$$destroyed){var parent=this.$parent;this.$broadcast("$destroy"),this.$$destroyed=!0,parent.$$childHead==this&&(parent.$$childHead=this.$$nextSibling),parent.$$childTail==this&&(parent.$$childTail=this.$$prevSibling),this.$$prevSibling&&(this.$$prevSibling.$$nextSibling=this.$$nextSibling),this.$$nextSibling&&(this.$$nextSibling.$$prevSibling=this.$$prevSibling),this.$parent=this.$$nextSibling=this.$$prevSibling=this.$$childHead=this.$$childTail=null}},$eval:function(expr,locals){return $parse(expr)(this,locals)},$evalAsync:function(expr){this.$$asyncQueue.push(expr)},$apply:function(expr){try{return beginPhase("$apply"),this.$eval(expr)}catch(e){$exceptionHandler(e)}finally{clearPhase();try{$rootScope.$digest()}catch(e){throw $exceptionHandler(e),e}}},$on:function(name,listener){var namedListeners=this.$$listeners[name];return namedListeners||(this.$$listeners[name]=namedListeners=[]),namedListeners.push(listener),function(){namedListeners[indexOf(namedListeners,listener)]=null}},$emit:function(name){var namedListeners,i,length,empty=[],scope=this,stopPropagation=!1,event={name:name,targetScope:scope,stopPropagation:function(){stopPropagation=!0},preventDefault:function(){event.defaultPrevented=!0},defaultPrevented:!1},listenerArgs=concat([event],arguments,1);do{for(namedListeners=scope.$$listeners[name]||empty,event.currentScope=scope,i=0,length=namedListeners.length;length>i;i++)if(namedListeners[i])try{if(namedListeners[i].apply(null,listenerArgs),stopPropagation)return event}catch(e){$exceptionHandler(e)}else namedListeners.splice(i,1),i--,length--;scope=scope.$parent}while(scope);return event},$broadcast:function(name){var listeners,i,length,target=this,current=target,next=target,event={name:name,targetScope:target,preventDefault:function(){event.defaultPrevented=!0},defaultPrevented:!1},listenerArgs=concat([event],arguments,1);do{for(current=next,event.currentScope=current,listeners=current.$$listeners[name]||[],i=0,length=listeners.length;length>i;i++)if(listeners[i])try{listeners[i].apply(null,listenerArgs)}catch(e){$exceptionHandler(e)}else listeners.splice(i,1),i--,length--;if(!(next=current.$$childHead||current!==target&&current.$$nextSibling))for(;current!==target&&!(next=current.$$nextSibling);)current=current.$parent}while(current=next);return event}};var $rootScope=new Scope;return $rootScope}]}function $SnifferProvider(){this.$get=["$window",function($window){var eventSupport={},android=int((/android (\d+)/.exec(lowercase($window.navigator.userAgent))||[])[1]);return{history:!(!$window.history||!$window.history.pushState||4>android),hashchange:"onhashchange"in $window&&(!$window.document.documentMode||$window.document.documentMode>7),hasEvent:function(event){if("input"==event&&9==msie)return!1;if(isUndefined(eventSupport[event])){var divElm=$window.document.createElement("div");eventSupport[event]="on"+event in divElm}return eventSupport[event]},csp:!1}}]}function $WindowProvider(){this.$get=valueFn(window)}function parseHeaders(headers){var key,val,i,parsed={};return headers?(forEach(headers.split("\n"),function(line){i=line.indexOf(":"),key=lowercase(trim(line.substr(0,i))),val=trim(line.substr(i+1)),key&&(parsed[key]?parsed[key]+=", "+val:parsed[key]=val)}),parsed):parsed}function headersGetter(headers){var headersObj=isObject(headers)?headers:undefined;return function(name){return headersObj||(headersObj=parseHeaders(headers)),name?headersObj[lowercase(name)]||null:headersObj}}function transformData(data,headers,fns){return isFunction(fns)?fns(data,headers):(forEach(fns,function(fn){data=fn(data,headers)}),data)}function isSuccess(status){return status>=200&&300>status}function $HttpProvider(){var JSON_START=/^\s*(\[|\{[^\{])/,JSON_END=/[\}\]]\s*$/,PROTECTION_PREFIX=/^\)\]\}',?\n/,$config=this.defaults={transformResponse:[function(data){return isString(data)&&(data=data.replace(PROTECTION_PREFIX,""),JSON_START.test(data)&&JSON_END.test(data)&&(data=fromJson(data,!0))),data}],transformRequest:[function(d){return isObject(d)&&!isFile(d)?toJson(d):d}],headers:{common:{Accept:"application/json, text/plain, */*","X-Requested-With":"XMLHttpRequest"},post:{"Content-Type":"application/json;charset=utf-8"},put:{"Content-Type":"application/json;charset=utf-8"}}},providerResponseInterceptors=this.responseInterceptors=[];this.$get=["$httpBackend","$browser","$cacheFactory","$rootScope","$q","$injector",function($httpBackend,$browser,$cacheFactory,$rootScope,$q,$injector){function $http(config){function transformResponse(response){var resp=extend({},response,{data:transformData(response.data,response.headers,respTransformFn)});return isSuccess(response.status)?resp:$q.reject(resp)}config.method=uppercase(config.method);var reqData,defHeaderName,lowercaseDefHeaderName,headerName,promise,reqTransformFn=config.transformRequest||$config.transformRequest,respTransformFn=config.transformResponse||$config.transformResponse,reqHeaders=extend({},config.headers),defHeaders=extend({"X-XSRF-TOKEN":$browser.cookies()["XSRF-TOKEN"]},$config.headers.common,$config.headers[lowercase(config.method)]);defaultHeadersIteration:for(defHeaderName in defHeaders){lowercaseDefHeaderName=lowercase(defHeaderName);for(headerName in config.headers)if(lowercase(headerName)===lowercaseDefHeaderName)continue defaultHeadersIteration;reqHeaders[defHeaderName]=defHeaders[defHeaderName]}if(isUndefined(config.data))for(var header in reqHeaders)if("content-type"===lowercase(header)){delete reqHeaders[header];break}return reqData=transformData(config.data,headersGetter(reqHeaders),reqTransformFn),promise=sendReq(config,reqData,reqHeaders),promise=promise.then(transformResponse,transformResponse),forEach(responseInterceptors,function(interceptor){promise=interceptor(promise)}),promise.success=function(fn){return promise.then(function(response){fn(response.data,response.status,response.headers,config)}),promise},promise.error=function(fn){return promise.then(null,function(response){fn(response.data,response.status,response.headers,config)}),promise},promise}function createShortMethods(){forEach(arguments,function(name){$http[name]=function(url,config){return $http(extend(config||{},{method:name,url:url}))}})}function createShortMethodsWithData(){forEach(arguments,function(name){$http[name]=function(url,data,config){return $http(extend(config||{},{method:name,url:url,data:data}))}})}function sendReq(config,reqData,reqHeaders){function done(status,response,headersString){cache&&(isSuccess(status)?cache.put(url,[status,response,parseHeaders(headersString)]):cache.remove(url)),resolvePromise(response,status,headersString),$rootScope.$apply()}function resolvePromise(response,status,headers){status=Math.max(status,0),(isSuccess(status)?deferred.resolve:deferred.reject)({data:response,status:status,headers:headersGetter(headers),config:config})}function removePendingReq(){var idx=indexOf($http.pendingRequests,config);-1!==idx&&$http.pendingRequests.splice(idx,1)}var cache,cachedResp,deferred=$q.defer(),promise=deferred.promise,url=buildUrl(config.url,config.params);if($http.pendingRequests.push(config),promise.then(removePendingReq,removePendingReq),config.cache&&"GET"==config.method&&(cache=isObject(config.cache)?config.cache:defaultCache),cache)if(cachedResp=cache.get(url)){if(cachedResp.then)return cachedResp.then(removePendingReq,removePendingReq),cachedResp;isArray(cachedResp)?resolvePromise(cachedResp[1],cachedResp[0],copy(cachedResp[2])):resolvePromise(cachedResp,200,{})}else cache.put(url,promise);return cachedResp||$httpBackend(config.method,url,reqData,done,reqHeaders,config.timeout,config.withCredentials),promise}function buildUrl(url,params){if(!params)return url;var parts=[];return forEachSorted(params,function(value,key){null!=value&&value!=undefined&&(isObject(value)&&(value=toJson(value)),parts.push(encodeURIComponent(key)+"="+encodeURIComponent(value)))}),url+(-1==url.indexOf("?")?"?":"&")+parts.join("&")}var defaultCache=$cacheFactory("$http"),responseInterceptors=[];return forEach(providerResponseInterceptors,function(interceptor){responseInterceptors.push(isString(interceptor)?$injector.get(interceptor):$injector.invoke(interceptor))}),$http.pendingRequests=[],createShortMethods("get","delete","head","jsonp"),createShortMethodsWithData("post","put"),$http.defaults=$config,$http}]}function $HttpBackendProvider(){this.$get=["$browser","$window","$document",function($browser,$window,$document){return createHttpBackend($browser,XHR,$browser.defer,$window.angular.callbacks,$document[0],$window.location.protocol.replace(":",""))}]}function createHttpBackend($browser,XHR,$browserDefer,callbacks,rawDocument,locationProtocol){function jsonpReq(url,done){var script=rawDocument.createElement("script"),doneWrapper=function(){rawDocument.body.removeChild(script),done&&done()};script.type="text/javascript",script.src=url,msie?script.onreadystatechange=function(){/loaded|complete/.test(script.readyState)&&doneWrapper()}:script.onload=script.onerror=doneWrapper,rawDocument.body.appendChild(script)}return function(method,url,post,callback,headers,timeout,withCredentials){function completeRequest(callback,status,response,headersString){var protocol=(url.match(URL_MATCH)||["",locationProtocol])[1];status="file"==protocol?response?200:404:status,status=1223==status?204:status,callback(status,response,headersString),$browser.$$completeOutstandingRequest(noop)}if($browser.$$incOutstandingRequestCount(),url=url||$browser.url(),"jsonp"==lowercase(method)){var callbackId="_"+(callbacks.counter++).toString(36);callbacks[callbackId]=function(data){callbacks[callbackId].data=data},jsonpReq(url.replace("JSON_CALLBACK","angular.callbacks."+callbackId),function(){callbacks[callbackId].data?completeRequest(callback,200,callbacks[callbackId].data):completeRequest(callback,-2),delete callbacks[callbackId]})}else{var xhr=new XHR;xhr.open(method,url,!0),forEach(headers,function(value,key){value&&xhr.setRequestHeader(key,value)});var status;xhr.onreadystatechange=function(){if(4==xhr.readyState){var responseHeaders=xhr.getAllResponseHeaders(),simpleHeaders=["Cache-Control","Content-Language","Content-Type","Expires","Last-Modified","Pragma"];responseHeaders||(responseHeaders="",forEach(simpleHeaders,function(header){var value=xhr.getResponseHeader(header);value&&(responseHeaders+=header+": "+value+"\n")})),completeRequest(callback,status||xhr.status,xhr.responseText,responseHeaders)}},withCredentials&&(xhr.withCredentials=!0),xhr.send(post||""),timeout>0&&$browserDefer(function(){status=-1,xhr.abort()},timeout)}}}function $LocaleProvider(){this.$get=function(){return{id:"en-us",NUMBER_FORMATS:{DECIMAL_SEP:".",GROUP_SEP:",",PATTERNS:[{minInt:1,minFrac:0,maxFrac:3,posPre:"",posSuf:"",negPre:"-",negSuf:"",gSize:3,lgSize:3},{minInt:1,minFrac:2,maxFrac:2,posPre:"¤",posSuf:"",negPre:"(¤",negSuf:")",gSize:3,lgSize:3}],CURRENCY_SYM:"$"},DATETIME_FORMATS:{MONTH:"January,February,March,April,May,June,July,August,September,October,November,December".split(","),SHORTMONTH:"Jan,Feb,Mar,Apr,May,Jun,Jul,Aug,Sep,Oct,Nov,Dec".split(","),DAY:"Sunday,Monday,Tuesday,Wednesday,Thursday,Friday,Saturday".split(","),SHORTDAY:"Sun,Mon,Tue,Wed,Thu,Fri,Sat".split(","),AMPMS:["AM","PM"],medium:"MMM d, y h:mm:ss a","short":"M/d/yy h:mm a",fullDate:"EEEE, MMMM d, y",longDate:"MMMM d, y",mediumDate:"MMM d, y",shortDate:"M/d/yy",mediumTime:"h:mm:ss a",shortTime:"h:mm a"},pluralCat:function(num){return 1===num?"one":"other"}}}}function $TimeoutProvider(){this.$get=["$rootScope","$browser","$q","$exceptionHandler",function($rootScope,$browser,$q,$exceptionHandler){function timeout(fn,delay,invokeApply){var timeoutId,deferred=$q.defer(),promise=deferred.promise,skipApply=isDefined(invokeApply)&&!invokeApply;return timeoutId=$browser.defer(function(){try{deferred.resolve(fn())}catch(e){deferred.reject(e),$exceptionHandler(e)}finally{delete deferreds[promise.$$timeoutId]}skipApply||$rootScope.$apply()},delay),promise.$$timeoutId=timeoutId,deferreds[timeoutId]=deferred,promise}var deferreds={};return timeout.cancel=function(promise){return promise&&promise.$$timeoutId in deferreds?(deferreds[promise.$$timeoutId].reject("canceled"),delete deferreds[promise.$$timeoutId],$browser.defer.cancel(promise.$$timeoutId)):!1},timeout}]}function $FilterProvider($provide){function register(name,factory){return $provide.factory(name+suffix,factory)}var suffix="Filter";this.register=register,this.$get=["$injector",function($injector){return function(name){return $injector.get(name+suffix)}}],register("currency",currencyFilter),register("date",dateFilter),register("filter",filterFilter),register("json",jsonFilter),register("limitTo",limitToFilter),register("lowercase",lowercaseFilter),register("number",numberFilter),register("orderBy",orderByFilter),register("uppercase",uppercaseFilter)}function filterFilter(){return function(array,expression){if(!isArray(array))return array;var predicates=[];predicates.check=function(value){for(var j=0;j<predicates.length;j++)if(!predicates[j](value))return!1;return!0};var search=function(obj,text){if("!"===text.charAt(0))return!search(obj,text.substr(1));switch(typeof obj){case"boolean":case"number":case"string":return(""+obj).toLowerCase().indexOf(text)>-1;case"object":for(var objKey in obj)if("$"!==objKey.charAt(0)&&search(obj[objKey],text))return!0;return!1;case"array":for(var i=0;i<obj.length;i++)if(search(obj[i],text))return!0;return!1;default:return!1}};switch(typeof expression){case"boolean":case"number":case"string":expression={$:expression};case"object":for(var key in expression)"$"==key?!function(){var text=(""+expression[key]).toLowerCase();text&&predicates.push(function(value){return search(value,text)})}():!function(){var path=key,text=(""+expression[key]).toLowerCase();text&&predicates.push(function(value){return search(getter(value,path),text)})}();break;case"function":predicates.push(expression);break;default:return array}for(var filtered=[],j=0;j<array.length;j++){var value=array[j];predicates.check(value)&&filtered.push(value)}return filtered}}function currencyFilter($locale){var formats=$locale.NUMBER_FORMATS;return function(amount,currencySymbol){return isUndefined(currencySymbol)&&(currencySymbol=formats.CURRENCY_SYM),formatNumber(amount,formats.PATTERNS[1],formats.GROUP_SEP,formats.DECIMAL_SEP,2).replace(/\u00A4/g,currencySymbol)}}function numberFilter($locale){var formats=$locale.NUMBER_FORMATS;return function(number,fractionSize){return formatNumber(number,formats.PATTERNS[0],formats.GROUP_SEP,formats.DECIMAL_SEP,fractionSize)}}function formatNumber(number,pattern,groupSep,decimalSep,fractionSize){if(isNaN(number)||!isFinite(number))return"";var isNegative=0>number;number=Math.abs(number);var numStr=number+"",formatedText="",parts=[],hasExponent=!1;if(-1!==numStr.indexOf("e")){var match=numStr.match(/([\d\.]+)e(-?)(\d+)/);match&&"-"==match[2]&&match[3]>fractionSize+1?numStr="0":(formatedText=numStr,hasExponent=!0)}if(hasExponent)fractionSize>0&&number>-1&&1>number&&(formatedText=number.toFixed(fractionSize));else{var fractionLen=(numStr.split(DECIMAL_SEP)[1]||"").length;isUndefined(fractionSize)&&(fractionSize=Math.min(Math.max(pattern.minFrac,fractionLen),pattern.maxFrac));var pow=Math.pow(10,fractionSize);number=Math.round(number*pow)/pow;var fraction=(""+number).split(DECIMAL_SEP),whole=fraction[0];fraction=fraction[1]||"";var pos=0,lgroup=pattern.lgSize,group=pattern.gSize;if(whole.length>=lgroup+group){pos=whole.length-lgroup;for(var i=0;pos>i;i++)0===(pos-i)%group&&0!==i&&(formatedText+=groupSep),formatedText+=whole.charAt(i)}for(i=pos;i<whole.length;i++)0===(whole.length-i)%lgroup&&0!==i&&(formatedText+=groupSep),formatedText+=whole.charAt(i);for(;fraction.length<fractionSize;)fraction+="0";fractionSize&&"0"!==fractionSize&&(formatedText+=decimalSep+fraction.substr(0,fractionSize))}return parts.push(isNegative?pattern.negPre:pattern.posPre),parts.push(formatedText),parts.push(isNegative?pattern.negSuf:pattern.posSuf),parts.join("")}function padNumber(num,digits,trim){var neg="";for(0>num&&(neg="-",num=-num),num=""+num;num.length<digits;)num="0"+num;return trim&&(num=num.substr(num.length-digits)),neg+num}function dateGetter(name,size,offset,trim){return offset=offset||0,function(date){var value=date["get"+name]();return(offset>0||value>-offset)&&(value+=offset),0===value&&-12==offset&&(value=12),padNumber(value,size,trim)}}function dateStrGetter(name,shortForm){return function(date,formats){var value=date["get"+name](),get=uppercase(shortForm?"SHORT"+name:name);return formats[get][value]}}function timeZoneGetter(date){var zone=-1*date.getTimezoneOffset(),paddedZone=zone>=0?"+":"";return paddedZone+=padNumber(Math[zone>0?"floor":"ceil"](zone/60),2)+padNumber(Math.abs(zone%60),2)}function ampmGetter(date,formats){return date.getHours()<12?formats.AMPMS[0]:formats.AMPMS[1]}function dateFilter($locale){function jsonStringToDate(string){var match;if(match=string.match(R_ISO8601_STR)){var date=new Date(0),tzHour=0,tzMin=0;return match[9]&&(tzHour=int(match[9]+match[10]),tzMin=int(match[9]+match[11])),date.setUTCFullYear(int(match[1]),int(match[2])-1,int(match[3])),date.setUTCHours(int(match[4]||0)-tzHour,int(match[5]||0)-tzMin,int(match[6]||0),int(match[7]||0)),date}return string}var R_ISO8601_STR=/^(\d{4})-?(\d\d)-?(\d\d)(?:T(\d\d)(?::?(\d\d)(?::?(\d\d)(?:\.(\d+))?)?)?(Z|([+-])(\d\d):?(\d\d))?)?$/;return function(date,format){var fn,match,text="",parts=[];if(format=format||"mediumDate",format=$locale.DATETIME_FORMATS[format]||format,isString(date)&&(date=NUMBER_STRING.test(date)?int(date):jsonStringToDate(date)),isNumber(date)&&(date=new Date(date)),!isDate(date))return date;
for(;format;)match=DATE_FORMATS_SPLIT.exec(format),match?(parts=concat(parts,match,1),format=parts.pop()):(parts.push(format),format=null);return forEach(parts,function(value){fn=DATE_FORMATS[value],text+=fn?fn(date,$locale.DATETIME_FORMATS):value.replace(/(^'|'$)/g,"").replace(/''/g,"'")}),text}}function jsonFilter(){return function(object){return toJson(object,!0)}}function limitToFilter(){return function(array,limit){if(!(array instanceof Array))return array;limit=int(limit);var i,n,out=[];if(!(array&&array instanceof Array))return out;for(limit>array.length?limit=array.length:limit<-array.length&&(limit=-array.length),limit>0?(i=0,n=limit):(i=array.length+limit,n=array.length);n>i;i++)out.push(array[i]);return out}}function orderByFilter($parse){return function(array,sortPredicate,reverseOrder){function comparator(o1,o2){for(var i=0;i<sortPredicate.length;i++){var comp=sortPredicate[i](o1,o2);if(0!==comp)return comp}return 0}function reverseComparator(comp,descending){return toBoolean(descending)?function(a,b){return comp(b,a)}:comp}function compare(v1,v2){var t1=typeof v1,t2=typeof v2;return t1==t2?("string"==t1&&(v1=v1.toLowerCase(),v2=v2.toLowerCase()),v1===v2?0:v2>v1?-1:1):t2>t1?-1:1}if(!isArray(array))return array;if(!sortPredicate)return array;sortPredicate=isArray(sortPredicate)?sortPredicate:[sortPredicate],sortPredicate=map(sortPredicate,function(predicate){var descending=!1,get=predicate||identity;return isString(predicate)&&(("+"==predicate.charAt(0)||"-"==predicate.charAt(0))&&(descending="-"==predicate.charAt(0),predicate=predicate.substring(1)),get=$parse(predicate)),reverseComparator(function(a,b){return compare(get(a),get(b))},descending)});for(var arrayCopy=[],i=0;i<array.length;i++)arrayCopy.push(array[i]);return arrayCopy.sort(reverseComparator(comparator,reverseOrder))}}function ngDirective(directive){return isFunction(directive)&&(directive={link:directive}),directive.restrict=directive.restrict||"AC",valueFn(directive)}function FormController(element,attrs){function toggleValidCss(isValid,validationErrorKey){validationErrorKey=validationErrorKey?"-"+snake_case(validationErrorKey,"-"):"",element.removeClass((isValid?INVALID_CLASS:VALID_CLASS)+validationErrorKey).addClass((isValid?VALID_CLASS:INVALID_CLASS)+validationErrorKey)}var form=this,parentForm=element.parent().controller("form")||nullFormCtrl,invalidCount=0,errors=form.$error={};form.$name=attrs.name||attrs.ngForm,form.$dirty=!1,form.$pristine=!0,form.$valid=!0,form.$invalid=!1,parentForm.$addControl(form),element.addClass(PRISTINE_CLASS),toggleValidCss(!0),form.$addControl=function(control){control.$name&&!form.hasOwnProperty(control.$name)&&(form[control.$name]=control)},form.$removeControl=function(control){control.$name&&form[control.$name]===control&&delete form[control.$name],forEach(errors,function(queue,validationToken){form.$setValidity(validationToken,!0,control)})},form.$setValidity=function(validationToken,isValid,control){var queue=errors[validationToken];if(isValid)queue&&(arrayRemove(queue,control),queue.length||(invalidCount--,invalidCount||(toggleValidCss(isValid),form.$valid=!0,form.$invalid=!1),errors[validationToken]=!1,toggleValidCss(!0,validationToken),parentForm.$setValidity(validationToken,!0,form)));else{if(invalidCount||toggleValidCss(isValid),queue){if(includes(queue,control))return}else errors[validationToken]=queue=[],invalidCount++,toggleValidCss(!1,validationToken),parentForm.$setValidity(validationToken,!1,form);queue.push(control),form.$valid=!1,form.$invalid=!0}},form.$setDirty=function(){element.removeClass(PRISTINE_CLASS).addClass(DIRTY_CLASS),form.$dirty=!0,form.$pristine=!1,parentForm.$setDirty()}}function isEmpty(value){return isUndefined(value)||""===value||null===value||value!==value}function textInputType(scope,element,attr,ctrl,$sniffer,$browser){var listener=function(){var value=trim(element.val());ctrl.$viewValue!==value&&scope.$apply(function(){ctrl.$setViewValue(value)})};if($sniffer.hasEvent("input"))element.bind("input",listener);else{var timeout,deferListener=function(){timeout||(timeout=$browser.defer(function(){listener(),timeout=null}))};element.bind("keydown",function(event){var key=event.keyCode;91===key||key>15&&19>key||key>=37&&40>=key||deferListener()}),element.bind("change",listener),$sniffer.hasEvent("paste")&&element.bind("paste cut",deferListener)}ctrl.$render=function(){element.val(isEmpty(ctrl.$viewValue)?"":ctrl.$viewValue)};var patternValidator,pattern=attr.ngPattern,validate=function(regexp,value){return isEmpty(value)||regexp.test(value)?(ctrl.$setValidity("pattern",!0),value):(ctrl.$setValidity("pattern",!1),undefined)};if(pattern&&(pattern.match(/^\/(.*)\/$/)?(pattern=new RegExp(pattern.substr(1,pattern.length-2)),patternValidator=function(value){return validate(pattern,value)}):patternValidator=function(value){var patternObj=scope.$eval(pattern);if(!patternObj||!patternObj.test)throw new Error("Expected "+pattern+" to be a RegExp but was "+patternObj);return validate(patternObj,value)},ctrl.$formatters.push(patternValidator),ctrl.$parsers.push(patternValidator)),attr.ngMinlength){var minlength=int(attr.ngMinlength),minLengthValidator=function(value){return!isEmpty(value)&&value.length<minlength?(ctrl.$setValidity("minlength",!1),undefined):(ctrl.$setValidity("minlength",!0),value)};ctrl.$parsers.push(minLengthValidator),ctrl.$formatters.push(minLengthValidator)}if(attr.ngMaxlength){var maxlength=int(attr.ngMaxlength),maxLengthValidator=function(value){return!isEmpty(value)&&value.length>maxlength?(ctrl.$setValidity("maxlength",!1),undefined):(ctrl.$setValidity("maxlength",!0),value)};ctrl.$parsers.push(maxLengthValidator),ctrl.$formatters.push(maxLengthValidator)}}function numberInputType(scope,element,attr,ctrl,$sniffer,$browser){if(textInputType(scope,element,attr,ctrl,$sniffer,$browser),ctrl.$parsers.push(function(value){var empty=isEmpty(value);return empty||NUMBER_REGEXP.test(value)?(ctrl.$setValidity("number",!0),""===value?null:empty?value:parseFloat(value)):(ctrl.$setValidity("number",!1),undefined)}),ctrl.$formatters.push(function(value){return isEmpty(value)?"":""+value}),attr.min){var min=parseFloat(attr.min),minValidator=function(value){return!isEmpty(value)&&min>value?(ctrl.$setValidity("min",!1),undefined):(ctrl.$setValidity("min",!0),value)};ctrl.$parsers.push(minValidator),ctrl.$formatters.push(minValidator)}if(attr.max){var max=parseFloat(attr.max),maxValidator=function(value){return!isEmpty(value)&&value>max?(ctrl.$setValidity("max",!1),undefined):(ctrl.$setValidity("max",!0),value)};ctrl.$parsers.push(maxValidator),ctrl.$formatters.push(maxValidator)}ctrl.$formatters.push(function(value){return isEmpty(value)||isNumber(value)?(ctrl.$setValidity("number",!0),value):(ctrl.$setValidity("number",!1),undefined)})}function urlInputType(scope,element,attr,ctrl,$sniffer,$browser){textInputType(scope,element,attr,ctrl,$sniffer,$browser);var urlValidator=function(value){return isEmpty(value)||URL_REGEXP.test(value)?(ctrl.$setValidity("url",!0),value):(ctrl.$setValidity("url",!1),undefined)};ctrl.$formatters.push(urlValidator),ctrl.$parsers.push(urlValidator)}function emailInputType(scope,element,attr,ctrl,$sniffer,$browser){textInputType(scope,element,attr,ctrl,$sniffer,$browser);var emailValidator=function(value){return isEmpty(value)||EMAIL_REGEXP.test(value)?(ctrl.$setValidity("email",!0),value):(ctrl.$setValidity("email",!1),undefined)};ctrl.$formatters.push(emailValidator),ctrl.$parsers.push(emailValidator)}function radioInputType(scope,element,attr,ctrl){isUndefined(attr.name)&&element.attr("name",nextUid()),element.bind("click",function(){element[0].checked&&scope.$apply(function(){ctrl.$setViewValue(attr.value)})}),ctrl.$render=function(){var value=attr.value;element[0].checked=value==ctrl.$viewValue},attr.$observe("value",ctrl.$render)}function checkboxInputType(scope,element,attr,ctrl){var trueValue=attr.ngTrueValue,falseValue=attr.ngFalseValue;isString(trueValue)||(trueValue=!0),isString(falseValue)||(falseValue=!1),element.bind("click",function(){scope.$apply(function(){ctrl.$setViewValue(element[0].checked)})}),ctrl.$render=function(){element[0].checked=ctrl.$viewValue},ctrl.$formatters.push(function(value){return value===trueValue}),ctrl.$parsers.push(function(value){return value?trueValue:falseValue})}function classDirective(name,selector){return name="ngClass"+name,ngDirective(function(scope,element,attr){function ngClassWatchAction(newVal){(selector===!0||scope.$index%2===selector)&&(oldVal&&!equals(newVal,oldVal)&&removeClass(oldVal),addClass(newVal)),oldVal=copy(newVal)}function removeClass(classVal){isObject(classVal)&&!isArray(classVal)&&(classVal=map(classVal,function(v,k){return v?k:void 0})),element.removeClass(isArray(classVal)?classVal.join(" "):classVal)}function addClass(classVal){isObject(classVal)&&!isArray(classVal)&&(classVal=map(classVal,function(v,k){return v?k:void 0})),classVal&&element.addClass(isArray(classVal)?classVal.join(" "):classVal)}var oldVal=undefined;scope.$watch(attr[name],ngClassWatchAction,!0),attr.$observe("class",function(){var ngClass=scope.$eval(attr[name]);ngClassWatchAction(ngClass,ngClass)}),"ngClass"!==name&&scope.$watch("$index",function($index,old$index){var mod=1&$index;1&mod!==old$index&&(mod===selector?addClass(scope.$eval(attr[name])):removeClass(scope.$eval(attr[name])))})})}var lowercase=function(string){return isString(string)?string.toLowerCase():string},uppercase=function(string){return isString(string)?string.toUpperCase():string},manualLowercase=function(s){return isString(s)?s.replace(/[A-Z]/g,function(ch){return String.fromCharCode(32|ch.charCodeAt(0))}):s},manualUppercase=function(s){return isString(s)?s.replace(/[a-z]/g,function(ch){return String.fromCharCode(-33&ch.charCodeAt(0))}):s};"i"!=="I".toLowerCase()&&(lowercase=manualLowercase,uppercase=manualUppercase);var jqLite,jQuery,angularModule,nodeName_,msie=int((/msie (\d+)/.exec(lowercase(navigator.userAgent))||[])[1]),slice=[].slice,push=[].push,toString=Object.prototype.toString,angular=window.angular||(window.angular={}),uid=["0","0","0"];noop.$inject=[],identity.$inject=[];var trim=function(){return String.prototype.trim?function(value){return isString(value)?value.trim():value}:function(value){return isString(value)?value.replace(/^\s*/,"").replace(/\s*$/,""):value}}();nodeName_=9>msie?function(element){return element=element.nodeName?element:element[0],element.scopeName&&"HTML"!=element.scopeName?uppercase(element.scopeName+":"+element.nodeName):element.nodeName}:function(element){return element.nodeName?element.nodeName:element[0].nodeName};var SNAKE_CASE_REGEXP=/[A-Z]/g,version={full:"1.0.8",major:1,minor:0,dot:8,codeName:"bubble-burst"},jqCache=JQLite.cache={},jqName=JQLite.expando="ng-"+(new Date).getTime(),jqId=1,addEventListenerFn=window.document.addEventListener?function(element,type,fn){element.addEventListener(type,fn,!1)}:function(element,type,fn){element.attachEvent("on"+type,fn)},removeEventListenerFn=window.document.removeEventListener?function(element,type,fn){element.removeEventListener(type,fn,!1)}:function(element,type,fn){element.detachEvent("on"+type,fn)},SPECIAL_CHARS_REGEXP=/([\:\-\_]+(.))/g,MOZ_HACK_REGEXP=/^moz([A-Z])/,JQLitePrototype=JQLite.prototype={ready:function(fn){function trigger(){fired||(fired=!0,fn())}var fired=!1;this.bind("DOMContentLoaded",trigger),JQLite(window).bind("load",trigger)},toString:function(){var value=[];return forEach(this,function(e){value.push(""+e)}),"["+value.join(", ")+"]"},eq:function(index){return index>=0?jqLite(this[index]):jqLite(this[this.length+index])},length:0,push:push,sort:[].sort,splice:[].splice},BOOLEAN_ATTR={};forEach("multiple,selected,checked,disabled,readOnly,required".split(","),function(value){BOOLEAN_ATTR[lowercase(value)]=value});var BOOLEAN_ELEMENTS={};forEach("input,select,option,textarea,button,form".split(","),function(value){BOOLEAN_ELEMENTS[uppercase(value)]=!0}),forEach({data:JQLiteData,inheritedData:JQLiteInheritedData,scope:function(element){return JQLiteInheritedData(element,"$scope")},controller:JQLiteController,injector:function(element){return JQLiteInheritedData(element,"$injector")},removeAttr:function(element,name){element.removeAttribute(name)},hasClass:JQLiteHasClass,css:function(element,name,value){if(name=camelCase(name),!isDefined(value)){var val;return 8>=msie&&(val=element.currentStyle&&element.currentStyle[name],""===val&&(val="auto")),val=val||element.style[name],8>=msie&&(val=""===val?undefined:val),val}element.style[name]=value},attr:function(element,name,value){var lowercasedName=lowercase(name);if(BOOLEAN_ATTR[lowercasedName]){if(!isDefined(value))return element[name]||(element.attributes.getNamedItem(name)||noop).specified?lowercasedName:undefined;value?(element[name]=!0,element.setAttribute(name,lowercasedName)):(element[name]=!1,element.removeAttribute(lowercasedName))}else if(isDefined(value))element.setAttribute(name,value);else if(element.getAttribute){var ret=element.getAttribute(name,2);return null===ret?undefined:ret}},prop:function(element,name,value){return isDefined(value)?(element[name]=value,void 0):element[name]},text:extend(9>msie?function(element,value){if(1==element.nodeType){if(isUndefined(value))return element.innerText;element.innerText=value}else{if(isUndefined(value))return element.nodeValue;element.nodeValue=value}}:function(element,value){return isUndefined(value)?element.textContent:(element.textContent=value,void 0)},{$dv:""}),val:function(element,value){if(isUndefined(value)){if("SELECT"===nodeName_(element)&&element.multiple){var result=[];return forEach(element.options,function(option){option.selected&&result.push(option.value||option.text)}),0===result.length?null:result}return element.value}element.value=value},html:function(element,value){if(isUndefined(value))return element.innerHTML;for(var i=0,childNodes=element.childNodes;i<childNodes.length;i++)JQLiteDealoc(childNodes[i]);element.innerHTML=value}},function(fn,name){JQLite.prototype[name]=function(arg1,arg2){var i,key;if((2==fn.length&&fn!==JQLiteHasClass&&fn!==JQLiteController?arg1:arg2)!==undefined){for(i=0;i<this.length;i++)fn(this[i],arg1,arg2);return this}if(isObject(arg1)){for(i=0;i<this.length;i++)if(fn===JQLiteData)fn(this[i],arg1);else for(key in arg1)fn(this[i],key,arg1[key]);return this}return this.length?fn(this[0],arg1,arg2):fn.$dv}}),forEach({removeData:JQLiteRemoveData,dealoc:JQLiteDealoc,bind:function bindFn(element,type,fn){var events=JQLiteExpandoStore(element,"events"),handle=JQLiteExpandoStore(element,"handle");events||JQLiteExpandoStore(element,"events",events={}),handle||JQLiteExpandoStore(element,"handle",handle=createEventHandler(element,events)),forEach(type.split(" "),function(type){var eventFns=events[type];if(!eventFns){if("mouseenter"==type||"mouseleave"==type){var contains=document.body.contains||document.body.compareDocumentPosition?function(a,b){var adown=9===a.nodeType?a.documentElement:a,bup=b&&b.parentNode;return a===bup||!(!bup||1!==bup.nodeType||!(adown.contains?adown.contains(bup):a.compareDocumentPosition&&16&a.compareDocumentPosition(bup)))}:function(a,b){if(b)for(;b=b.parentNode;)if(b===a)return!0;return!1};events[type]=[];var eventmap={mouseleave:"mouseout",mouseenter:"mouseover"};bindFn(element,eventmap[type],function(event){var target=this,related=event.relatedTarget;(!related||related!==target&&!contains(target,related))&&handle(event,type)})}else addEventListenerFn(element,type,handle),events[type]=[];eventFns=events[type]}eventFns.push(fn)})},unbind:JQLiteUnbind,replaceWith:function(element,replaceNode){var index,parent=element.parentNode;JQLiteDealoc(element),forEach(new JQLite(replaceNode),function(node){index?parent.insertBefore(node,index.nextSibling):parent.replaceChild(node,element),index=node})},children:function(element){var children=[];return forEach(element.childNodes,function(element){1===element.nodeType&&children.push(element)}),children},contents:function(element){return element.childNodes||[]},append:function(element,node){forEach(new JQLite(node),function(child){1===element.nodeType&&element.appendChild(child)})},prepend:function(element,node){if(1===element.nodeType){var index=element.firstChild;forEach(new JQLite(node),function(child){element.insertBefore(child,index)})}},wrap:function(element,wrapNode){wrapNode=jqLite(wrapNode)[0];var parent=element.parentNode;parent&&parent.replaceChild(wrapNode,element),wrapNode.appendChild(element)},remove:function(element){JQLiteDealoc(element);var parent=element.parentNode;parent&&parent.removeChild(element)},after:function(element,newElement){var index=element,parent=element.parentNode;forEach(new JQLite(newElement),function(node){parent.insertBefore(node,index.nextSibling),index=node})},addClass:JQLiteAddClass,removeClass:JQLiteRemoveClass,toggleClass:function(element,selector,condition){isUndefined(condition)&&(condition=!JQLiteHasClass(element,selector)),(condition?JQLiteAddClass:JQLiteRemoveClass)(element,selector)},parent:function(element){var parent=element.parentNode;return parent&&11!==parent.nodeType?parent:null},next:function(element){if(element.nextElementSibling)return element.nextElementSibling;for(var elm=element.nextSibling;null!=elm&&1!==elm.nodeType;)elm=elm.nextSibling;return elm},find:function(element,selector){return element.getElementsByTagName(selector)},clone:JQLiteClone,triggerHandler:function(element,eventName){var eventFns=(JQLiteExpandoStore(element,"events")||{})[eventName];forEach(eventFns,function(fn){fn.call(element,null)})}},function(fn,name){JQLite.prototype[name]=function(arg1,arg2){for(var value,i=0;i<this.length;i++)value==undefined?(value=fn(this[i],arg1,arg2),value!==undefined&&(value=jqLite(value))):JQLiteAddNodes(value,fn(this[i],arg1,arg2));return value==undefined?this:value}}),HashMap.prototype={put:function(key,value){this[hashKey(key)]=value},get:function(key){return this[hashKey(key)]},remove:function(key){var value=this[key=hashKey(key)];return delete this[key],value}},HashQueueMap.prototype={push:function(key,value){var array=this[key=hashKey(key)];array?array.push(value):this[key]=[value]},shift:function(key){var array=this[key=hashKey(key)];return array?1==array.length?(delete this[key],array[0]):array.shift():void 0},peek:function(key){var array=this[hashKey(key)];return array?array[0]:void 0}};var FN_ARGS=/^function\s*[^\(]*\(\s*([^\)]*)\)/m,FN_ARG_SPLIT=/,/,FN_ARG=/^\s*(_?)(\S+?)\1\s*$/,STRIP_COMMENTS=/((\/\/.*$)|(\/\*[\s\S]*?\*\/))/gm,NON_ASSIGNABLE_MODEL_EXPRESSION="Non-assignable model expression: ";$CompileProvider.$inject=["$provide"];var PREFIX_REGEXP=/^(x[\:\-_]|data[\:\-_])/i,URL_MATCH=/^([^:]+):\/\/(\w+:{0,1}\w*@)?(\{?[\w\.-]*\}?)(:([0-9]+))?(\/[^\?#]*)?(\?([^#]*))?(#(.*))?$/,PATH_MATCH=/^([^\?#]*)?(\?([^#]*))?(#(.*))?$/,HASH_MATCH=PATH_MATCH,DEFAULT_PORTS={http:80,https:443,ftp:21};LocationUrl.prototype={$$replace:!1,absUrl:locationGetter("$$absUrl"),url:function(url,replace){if(isUndefined(url))return this.$$url;var match=PATH_MATCH.exec(url);return match[1]&&this.path(decodeURIComponent(match[1])),(match[2]||match[1])&&this.search(match[3]||""),this.hash(match[5]||"",replace),this},protocol:locationGetter("$$protocol"),host:locationGetter("$$host"),port:locationGetter("$$port"),path:locationGetterSetter("$$path",function(path){return"/"==path.charAt(0)?path:"/"+path}),search:function(search,paramValue){return isUndefined(search)?this.$$search:(isDefined(paramValue)?null===paramValue?delete this.$$search[search]:this.$$search[search]=paramValue:this.$$search=isString(search)?parseKeyValue(search):search,this.$$compose(),this)},hash:locationGetterSetter("$$hash",identity),replace:function(){return this.$$replace=!0,this}},LocationHashbangUrl.prototype=inherit(LocationUrl.prototype),LocationHashbangInHtml5Url.prototype=inherit(LocationHashbangUrl.prototype);var OPERATORS={"null":function(){return null},"true":function(){return!0},"false":function(){return!1},undefined:noop,"+":function(self,locals,a,b){return a=a(self,locals),b=b(self,locals),isDefined(a)?isDefined(b)?a+b:a:isDefined(b)?b:undefined},"-":function(self,locals,a,b){return a=a(self,locals),b=b(self,locals),(isDefined(a)?a:0)-(isDefined(b)?b:0)},"*":function(self,locals,a,b){return a(self,locals)*b(self,locals)},"/":function(self,locals,a,b){return a(self,locals)/b(self,locals)},"%":function(self,locals,a,b){return a(self,locals)%b(self,locals)},"^":function(self,locals,a,b){return a(self,locals)^b(self,locals)},"=":noop,"==":function(self,locals,a,b){return a(self,locals)==b(self,locals)},"!=":function(self,locals,a,b){return a(self,locals)!=b(self,locals)},"<":function(self,locals,a,b){return a(self,locals)<b(self,locals)},">":function(self,locals,a,b){return a(self,locals)>b(self,locals)},"<=":function(self,locals,a,b){return a(self,locals)<=b(self,locals)},">=":function(self,locals,a,b){return a(self,locals)>=b(self,locals)},"&&":function(self,locals,a,b){return a(self,locals)&&b(self,locals)},"||":function(self,locals,a,b){return a(self,locals)||b(self,locals)},"&":function(self,locals,a,b){return a(self,locals)&b(self,locals)},"|":function(self,locals,a,b){return b(self,locals)(self,locals,a(self,locals))},"!":function(self,locals,a){return!a(self,locals)}},ESCAPE={n:"\n",f:"\f",r:"\r",t:"	",v:"","'":"'",'"':'"'},getterFnCache={},XHR=window.XMLHttpRequest||function(){try{return new ActiveXObject("Msxml2.XMLHTTP.6.0")}catch(e1){}try{return new ActiveXObject("Msxml2.XMLHTTP.3.0")}catch(e2){}try{return new ActiveXObject("Msxml2.XMLHTTP")}catch(e3){}throw new Error("This browser does not support XMLHttpRequest.")};$FilterProvider.$inject=["$provide"],currencyFilter.$inject=["$locale"],numberFilter.$inject=["$locale"];var DECIMAL_SEP=".",DATE_FORMATS={yyyy:dateGetter("FullYear",4),yy:dateGetter("FullYear",2,0,!0),y:dateGetter("FullYear",1),MMMM:dateStrGetter("Month"),MMM:dateStrGetter("Month",!0),MM:dateGetter("Month",2,1),M:dateGetter("Month",1,1),dd:dateGetter("Date",2),d:dateGetter("Date",1),HH:dateGetter("Hours",2),H:dateGetter("Hours",1),hh:dateGetter("Hours",2,-12),h:dateGetter("Hours",1,-12),mm:dateGetter("Minutes",2),m:dateGetter("Minutes",1),ss:dateGetter("Seconds",2),s:dateGetter("Seconds",1),EEEE:dateStrGetter("Day"),EEE:dateStrGetter("Day",!0),a:ampmGetter,Z:timeZoneGetter},DATE_FORMATS_SPLIT=/((?:[^yMdHhmsaZE']+)|(?:'(?:[^']|'')*')|(?:E+|y+|M+|d+|H+|h+|m+|s+|a|Z))(.*)/,NUMBER_STRING=/^\d+$/;dateFilter.$inject=["$locale"];var lowercaseFilter=valueFn(lowercase),uppercaseFilter=valueFn(uppercase);orderByFilter.$inject=["$parse"];var htmlAnchorDirective=valueFn({restrict:"E",compile:function(element,attr){return 8>=msie&&(attr.href||attr.name||attr.$set("href",""),element.append(document.createComment("IE fix"))),function(scope,element){element.bind("click",function(event){element.attr("href")||event.preventDefault()})}}}),ngAttributeAliasDirectives={};forEach(BOOLEAN_ATTR,function(propName,attrName){var normalized=directiveNormalize("ng-"+attrName);ngAttributeAliasDirectives[normalized]=function(){return{priority:100,compile:function(){return function(scope,element,attr){scope.$watch(attr[normalized],function(value){attr.$set(attrName,!!value)})}}}}}),forEach(["src","href"],function(attrName){var normalized=directiveNormalize("ng-"+attrName);ngAttributeAliasDirectives[normalized]=function(){return{priority:99,link:function(scope,element,attr){attr.$observe(normalized,function(value){value&&(attr.$set(attrName,value),msie&&element.prop(attrName,attr[attrName]))})}}}});var nullFormCtrl={$addControl:noop,$removeControl:noop,$setValidity:noop,$setDirty:noop};FormController.$inject=["$element","$attrs","$scope"];var formDirectiveFactory=function(isNgForm){return["$timeout",function($timeout){var formDirective={name:"form",restrict:"E",controller:FormController,compile:function(){return{pre:function(scope,formElement,attr,controller){if(!attr.action){var preventDefaultListener=function(event){event.preventDefault?event.preventDefault():event.returnValue=!1};addEventListenerFn(formElement[0],"submit",preventDefaultListener),formElement.bind("$destroy",function(){$timeout(function(){removeEventListenerFn(formElement[0],"submit",preventDefaultListener)},0,!1)})}var parentFormCtrl=formElement.parent().controller("form"),alias=attr.name||attr.ngForm;alias&&(scope[alias]=controller),parentFormCtrl&&formElement.bind("$destroy",function(){parentFormCtrl.$removeControl(controller),alias&&(scope[alias]=undefined),extend(controller,nullFormCtrl)})}}}};return isNgForm?extend(copy(formDirective),{restrict:"EAC"}):formDirective}]},formDirective=formDirectiveFactory(),ngFormDirective=formDirectiveFactory(!0),URL_REGEXP=/^(ftp|http|https):\/\/(\w+:{0,1}\w*@)?(\S+)(:[0-9]+)?(\/|\/([\w#!:.?+=&%@!\-\/]))?$/,EMAIL_REGEXP=/^[A-Za-z0-9._%+-]+@[A-Za-z0-9.-]+\.[A-Za-z]{2,6}$/,NUMBER_REGEXP=/^\s*(\-|\+)?(\d+|(\d*(\.\d*)))\s*$/,inputType={text:textInputType,number:numberInputType,url:urlInputType,email:emailInputType,radio:radioInputType,checkbox:checkboxInputType,hidden:noop,button:noop,submit:noop,reset:noop},inputDirective=["$browser","$sniffer",function($browser,$sniffer){return{restrict:"E",require:"?ngModel",link:function(scope,element,attr,ctrl){ctrl&&(inputType[lowercase(attr.type)]||inputType.text)(scope,element,attr,ctrl,$sniffer,$browser)}}}],VALID_CLASS="ng-valid",INVALID_CLASS="ng-invalid",PRISTINE_CLASS="ng-pristine",DIRTY_CLASS="ng-dirty",NgModelController=["$scope","$exceptionHandler","$attrs","$element","$parse",function($scope,$exceptionHandler,$attr,$element,$parse){function toggleValidCss(isValid,validationErrorKey){validationErrorKey=validationErrorKey?"-"+snake_case(validationErrorKey,"-"):"",$element.removeClass((isValid?INVALID_CLASS:VALID_CLASS)+validationErrorKey).addClass((isValid?VALID_CLASS:INVALID_CLASS)+validationErrorKey)}this.$viewValue=Number.NaN,this.$modelValue=Number.NaN,this.$parsers=[],this.$formatters=[],this.$viewChangeListeners=[],this.$pristine=!0,this.$dirty=!1,this.$valid=!0,this.$invalid=!1,this.$name=$attr.name;var ngModelGet=$parse($attr.ngModel),ngModelSet=ngModelGet.assign;if(!ngModelSet)throw Error(NON_ASSIGNABLE_MODEL_EXPRESSION+$attr.ngModel+" ("+startingTag($element)+")");this.$render=noop;var parentForm=$element.inheritedData("$formController")||nullFormCtrl,invalidCount=0,$error=this.$error={};$element.addClass(PRISTINE_CLASS),toggleValidCss(!0),this.$setValidity=function(validationErrorKey,isValid){$error[validationErrorKey]!==!isValid&&(isValid?($error[validationErrorKey]&&invalidCount--,invalidCount||(toggleValidCss(!0),this.$valid=!0,this.$invalid=!1)):(toggleValidCss(!1),this.$invalid=!0,this.$valid=!1,invalidCount++),$error[validationErrorKey]=!isValid,toggleValidCss(isValid,validationErrorKey),parentForm.$setValidity(validationErrorKey,isValid,this))},this.$setViewValue=function(value){this.$viewValue=value,this.$pristine&&(this.$dirty=!0,this.$pristine=!1,$element.removeClass(PRISTINE_CLASS).addClass(DIRTY_CLASS),parentForm.$setDirty()),forEach(this.$parsers,function(fn){value=fn(value)}),this.$modelValue!==value&&(this.$modelValue=value,ngModelSet($scope,value),forEach(this.$viewChangeListeners,function(listener){try{listener()}catch(e){$exceptionHandler(e)}}))};var ctrl=this;$scope.$watch(function(){var value=ngModelGet($scope);if(ctrl.$modelValue!==value){var formatters=ctrl.$formatters,idx=formatters.length;for(ctrl.$modelValue=value;idx--;)value=formatters[idx](value);ctrl.$viewValue!==value&&(ctrl.$viewValue=value,ctrl.$render())}})}],ngModelDirective=function(){return{require:["ngModel","^?form"],controller:NgModelController,link:function(scope,element,attr,ctrls){var modelCtrl=ctrls[0],formCtrl=ctrls[1]||nullFormCtrl;formCtrl.$addControl(modelCtrl),element.bind("$destroy",function(){formCtrl.$removeControl(modelCtrl)})}}},ngChangeDirective=valueFn({require:"ngModel",link:function(scope,element,attr,ctrl){ctrl.$viewChangeListeners.push(function(){scope.$eval(attr.ngChange)})}}),requiredDirective=function(){return{require:"?ngModel",link:function(scope,elm,attr,ctrl){if(ctrl){attr.required=!0;var validator=function(value){return attr.required&&(isEmpty(value)||value===!1)?(ctrl.$setValidity("required",!1),void 0):(ctrl.$setValidity("required",!0),value)};ctrl.$formatters.push(validator),ctrl.$parsers.unshift(validator),attr.$observe("required",function(){validator(ctrl.$viewValue)})}}}},ngListDirective=function(){return{require:"ngModel",link:function(scope,element,attr,ctrl){var match=/\/(.*)\//.exec(attr.ngList),separator=match&&new RegExp(match[1])||attr.ngList||",",parse=function(viewValue){var list=[];return viewValue&&forEach(viewValue.split(separator),function(value){value&&list.push(trim(value))}),list};ctrl.$parsers.push(parse),ctrl.$formatters.push(function(value){return isArray(value)?value.join(", "):undefined})}}},CONSTANT_VALUE_REGEXP=/^(true|false|\d+)$/,ngValueDirective=function(){return{priority:100,compile:function(tpl,tplAttr){return CONSTANT_VALUE_REGEXP.test(tplAttr.ngValue)?function(scope,elm,attr){attr.$set("value",scope.$eval(attr.ngValue))}:function(scope,elm,attr){scope.$watch(attr.ngValue,function(value){attr.$set("value",value)})}}}},ngBindDirective=ngDirective(function(scope,element,attr){element.addClass("ng-binding").data("$binding",attr.ngBind),scope.$watch(attr.ngBind,function(value){element.text(value==undefined?"":value)})}),ngBindTemplateDirective=["$interpolate",function($interpolate){return function(scope,element,attr){var interpolateFn=$interpolate(element.attr(attr.$attr.ngBindTemplate));element.addClass("ng-binding").data("$binding",interpolateFn),attr.$observe("ngBindTemplate",function(value){element.text(value)})}}],ngBindHtmlUnsafeDirective=[function(){return function(scope,element,attr){element.addClass("ng-binding").data("$binding",attr.ngBindHtmlUnsafe),scope.$watch(attr.ngBindHtmlUnsafe,function(value){element.html(value||"")})}}],ngClassDirective=classDirective("",!0),ngClassOddDirective=classDirective("Odd",0),ngClassEvenDirective=classDirective("Even",1),ngCloakDirective=ngDirective({compile:function(element,attr){attr.$set("ngCloak",undefined),element.removeClass("ng-cloak")}}),ngControllerDirective=[function(){return{scope:!0,controller:"@"}}],ngCspDirective=["$sniffer",function($sniffer){return{priority:1e3,compile:function(){$sniffer.csp=!0}}}],ngEventDirectives={};forEach("click dblclick mousedown mouseup mouseover mouseout mousemove mouseenter mouseleave submit".split(" "),function(name){var directiveName=directiveNormalize("ng-"+name);ngEventDirectives[directiveName]=["$parse",function($parse){return function(scope,element,attr){var fn=$parse(attr[directiveName]);element.bind(lowercase(name),function(event){scope.$apply(function(){fn(scope,{$event:event})})})}}]});var ngIncludeDirective=["$http","$templateCache","$anchorScroll","$compile",function($http,$templateCache,$anchorScroll,$compile){return{restrict:"ECA",terminal:!0,compile:function(element,attr){var srcExp=attr.ngInclude||attr.src,onloadExp=attr.onload||"",autoScrollExp=attr.autoscroll;return function(scope,element){var childScope,changeCounter=0,clearContent=function(){childScope&&(childScope.$destroy(),childScope=null),element.html("")};scope.$watch(srcExp,function(src){var thisChangeId=++changeCounter;src?$http.get(src,{cache:$templateCache}).success(function(response){thisChangeId===changeCounter&&(childScope&&childScope.$destroy(),childScope=scope.$new(),element.html(response),$compile(element.contents())(childScope),!isDefined(autoScrollExp)||autoScrollExp&&!scope.$eval(autoScrollExp)||$anchorScroll(),childScope.$emit("$includeContentLoaded"),scope.$eval(onloadExp))}).error(function(){thisChangeId===changeCounter&&clearContent()}):clearContent()})}}}}],ngInitDirective=ngDirective({compile:function(){return{pre:function(scope,element,attrs){scope.$eval(attrs.ngInit)}}}}),ngNonBindableDirective=ngDirective({terminal:!0,priority:1e3}),ngPluralizeDirective=["$locale","$interpolate",function($locale,$interpolate){var BRACE=/{}/g;
return{restrict:"EA",link:function(scope,element,attr){var numberExp=attr.count,whenExp=element.attr(attr.$attr.when),offset=attr.offset||0,whens=scope.$eval(whenExp),whensExpFns={},startSymbol=$interpolate.startSymbol(),endSymbol=$interpolate.endSymbol();forEach(whens,function(expression,key){whensExpFns[key]=$interpolate(expression.replace(BRACE,startSymbol+numberExp+"-"+offset+endSymbol))}),scope.$watch(function(){var value=parseFloat(scope.$eval(numberExp));return isNaN(value)?"":(value in whens||(value=$locale.pluralCat(value-offset)),whensExpFns[value](scope,element,!0))},function(newVal){element.text(newVal)})}}}],ngRepeatDirective=ngDirective({transclude:"element",priority:1e3,terminal:!0,compile:function(element,attr,linker){return function(scope,iterStartElement,attr){var lhs,rhs,valueIdent,keyIdent,expression=attr.ngRepeat,match=expression.match(/^\s*(.+)\s+in\s+(.*)\s*$/);if(!match)throw Error("Expected ngRepeat in form of '_item_ in _collection_' but got '"+expression+"'.");if(lhs=match[1],rhs=match[2],match=lhs.match(/^(?:([\$\w]+)|\(([\$\w]+)\s*,\s*([\$\w]+)\))$/),!match)throw Error("'item' in 'item in collection' should be identifier or (key, value) but got '"+lhs+"'.");valueIdent=match[3]||match[1],keyIdent=match[2];var lastOrder=new HashQueueMap;scope.$watch(function(scope){var index,length,arrayBound,childScope,key,value,array,last,collection=scope.$eval(rhs),cursor=iterStartElement,nextOrder=new HashQueueMap;if(isArray(collection))array=collection||[];else{array=[];for(key in collection)collection.hasOwnProperty(key)&&"$"!=key.charAt(0)&&array.push(key);array.sort()}for(arrayBound=array.length-1,index=0,length=array.length;length>index;index++)key=collection===array?index:array[index],value=collection[key],last=lastOrder.shift(value),last?(childScope=last.scope,nextOrder.push(value,last),index===last.index?cursor=last.element:(last.index=index,cursor.after(last.element),cursor=last.element)):childScope=scope.$new(),childScope[valueIdent]=value,keyIdent&&(childScope[keyIdent]=key),childScope.$index=index,childScope.$first=0===index,childScope.$last=index===arrayBound,childScope.$middle=!(childScope.$first||childScope.$last),last||linker(childScope,function(clone){cursor.after(clone),last={scope:childScope,element:cursor=clone,index:index},nextOrder.push(value,last)});for(key in lastOrder)if(lastOrder.hasOwnProperty(key))for(array=lastOrder[key];array.length;)value=array.pop(),value.element.remove(),value.scope.$destroy();lastOrder=nextOrder})}}}),ngShowDirective=ngDirective(function(scope,element,attr){scope.$watch(attr.ngShow,function(value){element.css("display",toBoolean(value)?"":"none")})}),ngHideDirective=ngDirective(function(scope,element,attr){scope.$watch(attr.ngHide,function(value){element.css("display",toBoolean(value)?"none":"")})}),ngStyleDirective=ngDirective(function(scope,element,attr){scope.$watch(attr.ngStyle,function(newStyles,oldStyles){oldStyles&&newStyles!==oldStyles&&forEach(oldStyles,function(val,style){element.css(style,"")}),newStyles&&element.css(newStyles)},!0)}),ngSwitchDirective=valueFn({restrict:"EA",require:"ngSwitch",controller:["$scope",function(){this.cases={}}],link:function(scope,element,attr,ctrl){var selectedTransclude,selectedElement,selectedScope,watchExpr=attr.ngSwitch||attr.on;scope.$watch(watchExpr,function(value){selectedElement&&(selectedScope.$destroy(),selectedElement.remove(),selectedElement=selectedScope=null),(selectedTransclude=ctrl.cases["!"+value]||ctrl.cases["?"])&&(scope.$eval(attr.change),selectedScope=scope.$new(),selectedTransclude(selectedScope,function(caseElement){selectedElement=caseElement,element.append(caseElement)}))})}}),ngSwitchWhenDirective=ngDirective({transclude:"element",priority:500,require:"^ngSwitch",compile:function(element,attrs,transclude){return function(scope,element,attr,ctrl){ctrl.cases["!"+attrs.ngSwitchWhen]=transclude}}}),ngSwitchDefaultDirective=ngDirective({transclude:"element",priority:500,require:"^ngSwitch",compile:function(element,attrs,transclude){return function(scope,element,attr,ctrl){ctrl.cases["?"]=transclude}}}),ngTranscludeDirective=ngDirective({controller:["$transclude","$element",function($transclude,$element){$transclude(function(clone){$element.append(clone)})}]}),ngViewDirective=["$http","$templateCache","$route","$anchorScroll","$compile","$controller",function($http,$templateCache,$route,$anchorScroll,$compile,$controller){return{restrict:"ECA",terminal:!0,link:function(scope,element,attr){function destroyLastScope(){lastScope&&(lastScope.$destroy(),lastScope=null)}function clearContent(){element.html(""),destroyLastScope()}function update(){var locals=$route.current&&$route.current.locals,template=locals&&locals.$template;if(template){element.html(template),destroyLastScope();var controller,link=$compile(element.contents()),current=$route.current;lastScope=current.scope=scope.$new(),current.controller&&(locals.$scope=lastScope,controller=$controller(current.controller,locals),element.children().data("$ngControllerController",controller)),link(lastScope),lastScope.$emit("$viewContentLoaded"),lastScope.$eval(onloadExp),$anchorScroll()}else clearContent()}var lastScope,onloadExp=attr.onload||"";scope.$on("$routeChangeSuccess",update),update()}}}],scriptDirective=["$templateCache",function($templateCache){return{restrict:"E",terminal:!0,compile:function(element,attr){if("text/ng-template"==attr.type){var templateUrl=attr.id,text=element[0].text;$templateCache.put(templateUrl,text)}}}}],ngOptionsDirective=valueFn({terminal:!0}),selectDirective=["$compile","$parse",function($compile,$parse){var NG_OPTIONS_REGEXP=/^\s*(.*?)(?:\s+as\s+(.*?))?(?:\s+group\s+by\s+(.*))?\s+for\s+(?:([\$\w][\$\w\d]*)|(?:\(\s*([\$\w][\$\w\d]*)\s*,\s*([\$\w][\$\w\d]*)\s*\)))\s+in\s+(.*)$/,nullModelCtrl={$setViewValue:noop};return{restrict:"E",require:["select","?ngModel"],controller:["$element","$scope","$attrs",function($element,$scope,$attrs){var nullOption,unknownOption,self=this,optionsMap={},ngModelCtrl=nullModelCtrl;self.databound=$attrs.ngModel,self.init=function(ngModelCtrl_,nullOption_,unknownOption_){ngModelCtrl=ngModelCtrl_,nullOption=nullOption_,unknownOption=unknownOption_},self.addOption=function(value){optionsMap[value]=!0,ngModelCtrl.$viewValue==value&&($element.val(value),unknownOption.parent()&&unknownOption.remove())},self.removeOption=function(value){this.hasOption(value)&&(delete optionsMap[value],ngModelCtrl.$viewValue==value&&this.renderUnknownOption(value))},self.renderUnknownOption=function(val){var unknownVal="? "+hashKey(val)+" ?";unknownOption.val(unknownVal),$element.prepend(unknownOption),$element.val(unknownVal),unknownOption.prop("selected",!0)},self.hasOption=function(value){return optionsMap.hasOwnProperty(value)},$scope.$on("$destroy",function(){self.renderUnknownOption=noop})}],link:function(scope,element,attr,ctrls){function Single(scope,selectElement,ngModelCtrl,selectCtrl){ngModelCtrl.$render=function(){var viewValue=ngModelCtrl.$viewValue;selectCtrl.hasOption(viewValue)?(unknownOption.parent()&&unknownOption.remove(),selectElement.val(viewValue),""===viewValue&&emptyOption.prop("selected",!0)):isUndefined(viewValue)&&emptyOption?selectElement.val(""):selectCtrl.renderUnknownOption(viewValue)},selectElement.bind("change",function(){scope.$apply(function(){unknownOption.parent()&&unknownOption.remove(),ngModelCtrl.$setViewValue(selectElement.val())})})}function Multiple(scope,selectElement,ctrl){var lastView;ctrl.$render=function(){var items=new HashMap(ctrl.$viewValue);forEach(selectElement.find("option"),function(option){option.selected=isDefined(items.get(option.value))})},scope.$watch(function(){equals(lastView,ctrl.$viewValue)||(lastView=copy(ctrl.$viewValue),ctrl.$render())}),selectElement.bind("change",function(){scope.$apply(function(){var array=[];forEach(selectElement.find("option"),function(option){option.selected&&array.push(option.value)}),ctrl.$setViewValue(array)})})}function Options(scope,selectElement,ctrl){function render(){var optionGroupName,optionGroup,option,existingParent,existingOptions,existingOption,groupLength,length,groupIndex,index,selected,lastElement,element,label,optionGroups={"":[]},optionGroupNames=[""],modelValue=ctrl.$modelValue,values=valuesFn(scope)||[],keys=keyName?sortedKeys(values):values,locals={},selectedSet=!1;for(multiple&&(selectedSet=new HashMap(modelValue)),index=0;length=keys.length,length>index;index++)locals[valueName]=values[keyName?locals[keyName]=keys[index]:index],optionGroupName=groupByFn(scope,locals)||"",(optionGroup=optionGroups[optionGroupName])||(optionGroup=optionGroups[optionGroupName]=[],optionGroupNames.push(optionGroupName)),multiple?selected=selectedSet.remove(valueFn(scope,locals))!=undefined:(selected=modelValue===valueFn(scope,locals),selectedSet=selectedSet||selected),label=displayFn(scope,locals),label=label===undefined?"":label,optionGroup.push({id:keyName?keys[index]:index,label:label,selected:selected});for(multiple||(nullOption||null===modelValue?optionGroups[""].unshift({id:"",label:"",selected:!selectedSet}):selectedSet||optionGroups[""].unshift({id:"?",label:"",selected:!0})),groupIndex=0,groupLength=optionGroupNames.length;groupLength>groupIndex;groupIndex++){for(optionGroupName=optionGroupNames[groupIndex],optionGroup=optionGroups[optionGroupName],optionGroupsCache.length<=groupIndex?(existingParent={element:optGroupTemplate.clone().attr("label",optionGroupName),label:optionGroup.label},existingOptions=[existingParent],optionGroupsCache.push(existingOptions),selectElement.append(existingParent.element)):(existingOptions=optionGroupsCache[groupIndex],existingParent=existingOptions[0],existingParent.label!=optionGroupName&&existingParent.element.attr("label",existingParent.label=optionGroupName)),lastElement=null,index=0,length=optionGroup.length;length>index;index++)option=optionGroup[index],(existingOption=existingOptions[index+1])?(lastElement=existingOption.element,existingOption.label!==option.label&&lastElement.text(existingOption.label=option.label),existingOption.id!==option.id&&lastElement.val(existingOption.id=option.id),lastElement[0].selected!==option.selected&&lastElement.prop("selected",existingOption.selected=option.selected)):(""===option.id&&nullOption?element=nullOption:(element=optionTemplate.clone()).val(option.id).attr("selected",option.selected).text(option.label),existingOptions.push(existingOption={element:element,label:option.label,id:option.id,selected:option.selected}),lastElement?lastElement.after(element):existingParent.element.append(element),lastElement=element);for(index++;existingOptions.length>index;)existingOptions.pop().element.remove()}for(;optionGroupsCache.length>groupIndex;)optionGroupsCache.pop()[0].element.remove()}var match;if(!(match=optionsExp.match(NG_OPTIONS_REGEXP)))throw Error("Expected ngOptions in form of '_select_ (as _label_)? for (_key_,)?_value_ in _collection_' but got '"+optionsExp+"'.");var displayFn=$parse(match[2]||match[1]),valueName=match[4]||match[6],keyName=match[5],groupByFn=$parse(match[3]||""),valueFn=$parse(match[2]?match[1]:valueName),valuesFn=$parse(match[7]),optionGroupsCache=[[{element:selectElement,label:""}]];nullOption&&($compile(nullOption)(scope),nullOption.removeClass("ng-scope"),nullOption.remove()),selectElement.html(""),selectElement.bind("change",function(){scope.$apply(function(){var optionGroup,key,value,optionElement,index,groupIndex,length,groupLength,collection=valuesFn(scope)||[],locals={};if(multiple)for(value=[],groupIndex=0,groupLength=optionGroupsCache.length;groupLength>groupIndex;groupIndex++)for(optionGroup=optionGroupsCache[groupIndex],index=1,length=optionGroup.length;length>index;index++)(optionElement=optionGroup[index].element)[0].selected&&(key=optionElement.val(),keyName&&(locals[keyName]=key),locals[valueName]=collection[key],value.push(valueFn(scope,locals)));else key=selectElement.val(),"?"==key?value=undefined:""==key?value=null:(locals[valueName]=collection[key],keyName&&(locals[keyName]=key),value=valueFn(scope,locals));ctrl.$setViewValue(value)})}),ctrl.$render=render,scope.$watch(render)}if(ctrls[1]){for(var emptyOption,selectCtrl=ctrls[0],ngModelCtrl=ctrls[1],multiple=attr.multiple,optionsExp=attr.ngOptions,nullOption=!1,optionTemplate=jqLite(document.createElement("option")),optGroupTemplate=jqLite(document.createElement("optgroup")),unknownOption=optionTemplate.clone(),i=0,children=element.children(),ii=children.length;ii>i;i++)if(""==children[i].value){emptyOption=nullOption=children.eq(i);break}if(selectCtrl.init(ngModelCtrl,nullOption,unknownOption),multiple&&(attr.required||attr.ngRequired)){var requiredValidator=function(value){return ngModelCtrl.$setValidity("required",!attr.required||value&&value.length),value};ngModelCtrl.$parsers.push(requiredValidator),ngModelCtrl.$formatters.unshift(requiredValidator),attr.$observe("required",function(){requiredValidator(ngModelCtrl.$viewValue)})}optionsExp?Options(scope,element,ngModelCtrl):multiple?Multiple(scope,element,ngModelCtrl):Single(scope,element,ngModelCtrl,selectCtrl)}}}}],optionDirective=["$interpolate",function($interpolate){var nullSelectCtrl={addOption:noop,removeOption:noop};return{restrict:"E",priority:100,compile:function(element,attr){if(isUndefined(attr.value)){var interpolateFn=$interpolate(element.text(),!0);interpolateFn||attr.$set("value",element.text())}return function(scope,element,attr){var selectCtrlName="$selectController",parent=element.parent(),selectCtrl=parent.data(selectCtrlName)||parent.parent().data(selectCtrlName);selectCtrl&&selectCtrl.databound?element.prop("selected",!1):selectCtrl=nullSelectCtrl,interpolateFn?scope.$watch(interpolateFn,function(newVal,oldVal){attr.$set("value",newVal),newVal!==oldVal&&selectCtrl.removeOption(oldVal),selectCtrl.addOption(newVal)}):selectCtrl.addOption(attr.value),element.bind("$destroy",function(){selectCtrl.removeOption(attr.value)})}}}}],styleDirective=valueFn({restrict:"E",terminal:!0});bindJQuery(),publishExternalAPI(angular),jqLite(document).ready(function(){angularInit(document,bootstrap)})}(window,document),angular.element(document).find("head").append('<style type="text/css">@charset "UTF-8";[ng\\:cloak],[ng-cloak],[data-ng-cloak],[x-ng-cloak],.ng-cloak,.x-ng-cloak{display:none !important;}ng\\:form{display:block;}</style>');